#include "gta.h"
#include "../Mem/mem.h"
#include "../BDD/bdd_external.h"
#include "gta_changes.h"
#include "gta_artmc_lib.h"
#include <stdlib.h>
#include <stdio.h>

#ifdef ABSTR_DEBUG
#include "../input.h"
#endif

//#define USE_SHARE

int get_num(int num,int *state_list,int states) {
	int i,res;
	res=0;
	for(i=0;i<states;i++)
		if (state_list[i]==num) res++;
	return res;
}

GTA *collaps2(GTA *G, int *state_list) {
	int i, j, k, states, max, max_orig, max_real, num,index,aux,aux2, done;
	Table **tables;
	GTA *H, *J;
	tables= (Table **) get_tables(G);
	BddNode *e = (BddNode *) mem_alloc(sizeof(BddNode));
	/* number of states in state space[1] of G */
	states=G->ss[1].size;
	/* search for maximal index */
	max=0;
	for (i = 0; i < tables[1]->noelems; i++) {
		if (tables[1]->elms[i].idx>max) max=tables[1]->elms[i].idx;
	}
	/*printf("states: %i\n",states);
	for (i=0;i<states;i++) printf("%i ",state_list[i]);
	printf("\n");*/
	max++;
	max_orig=max;
	max_real=-1;
	index=tables[1]->noelems;
	for(i=0;i<states;i++) {
		num=get_num(i,state_list,states);
		if (num<=1) continue; /* no collaps */
#ifdef USE_SHARE
		max=max_orig;
#endif
		aux=index;
		aux2=tables[1]->noelems;
		j=0;
		for(done=0;done<num;done++) {
			while (state_list[j]!=i) j++;
			if (G->ss[1].initial==j) {
				printf("ERROR: collapsing of initial state - MAY BE error \n"); 
				exit(0);
			}
			if ((done!=0)&&(done<num-1)) {
				e->idx = max;
				e->lo = index+1;
				e->hi = index+2; 
				tableInsert(tables[1],e);
				index++;
				max++;
			}
			e->idx = -1;
			e->lo = j;
			e->hi = 0; 
			tableInsert(tables[1],e);
			index++;
			j++;
		}
		for (j = 0; j < aux2; j++) {
			if ((tables[1]->elms[j].idx==-1)&&
				(state_list[tables[1]->elms[j].lo]==i)) {
				tables[1]->elms[j].idx=max;
				tables[1]->elms[j].lo= aux;
				tables[1]->elms[j].hi= aux+1;
			}
		}
		if (max>max_real) max_real=max;
#ifndef USE_SHARE
		max++; 
#endif
	}
	H= (GTA *) put_tables(tables,G);
	
	for(i=max_orig;i<=max_real;i++) {
		J=gtaMinimize(H);
		gtaFree(H);
		H=gtaQuotientAndProject(J, i, 0);
		printf("*\n");
		gtaFree(J);
	}
	J=gtaMinimize(H);
	gtaFree(H);
	/* leave memory free */
	for (i = 0; i < guide.numSs; i++)
		tableFree(tables[i]);
	mem_free(tables);

	/* Test for safety */
	if (!is_included(G,J)) {
		printf("ERROR: Collaps: not safe...\n... incorrect implementation???\n");
		exit(0);
	}
	 
#ifdef ABSTR_DEBUG
	/* Debuging abstractions */
	if (!is_included(J,G)) {
		printf("Collapsing done:\n");
		for (i=0;i<states;i++) printf("%i ",state_list[i]);
		printf("\n");
		save_automaton(G,"collaps-in.gta");
		save_automaton(J,"collaps-out.gta");
		printf("type number and pres enter to continue ...\n");
		scanf("%i",&i);
	}
#endif
	return J;
}

/* bacward compatibility - bad name of function */
GTA *colaps2(GTA *G, int *state_list) {
	collaps2(G,state_list);
}
	

