#include "gta.h"

#define dir_file "directions.txt"
#define checkers_file "check.txt"

/* If you vant a verbose output, define VERBOSE */
//#define VERBOSE

/* Define STATISTICS if you want:
 * * on-the-fly information about configuration sizes 
 * * compute number of refinements
 */
#define STATISTICS

/* define FIRST_UNION, if you want to make first union, and than abstraction */
//#define FIRST_UNION

/* define type of abstraction here 
 * !!! just one abstraction can be defined in one time 
 * - otherwice it does not work properly (seq fault, garbage in memory, etc ... 
 *
 * If you want to set the type of abstraction externally by -DPREDICATES, it is recomended 
 * to use it togather with -DABSTR_SET. This ensure, that there will be defined only 
 * one type of abstraction in one time */

#ifndef ABSTR_SET

//#define FIN_HEIGHT
//#define FIN_HEIGHT_GENERIC
//#define NEIGHBOUR
//#define FIN_UP
#define PREDICATES
/* predicates can be combined with finite height - set PREDICATES and COMBINE_PRED_FH
   !!! don't set FIN_HEIGHT
   refinement is done only at level of predicates */
//#define COMBINE_PRED_FH
/* end of abstraction type definition */

#endif



//#define HISTORY
/* If you wan to use reverse run to investigate bad configurations, define REMEMBER_CONFIGS */
#define REMEMBER_CONFIGS

#define RESTRICT
#define RESTRICT_PREDICATE


/* If you wan automatic descriptor updating after command x.next=y, 
 * define macro UPDATE_DESCRIPTOR */
#define UPDATE_DESCRIPTOR

/* Perform cover check before descriptor update
 * - descriptor update is started only if cover check reply NO 
 * - !!! abstraction creates new states => usually answer is NO :-( */
#define COVER_CHECK

/* type can have following values:
 * 0 - no successors - terminus of program
 * 1 - one successor - normal command
 * 2 - two successors - if command
 * 3 - x.next=y
 * 4 - x=y.next
 * */
typedef struct {
	int type,t,f,mark;
	GTA *transd,*transd2,**settoken;
	/* settoken field can be used also as transd3, transd4, ... */
} program_type;

typedef struct {
	int type,line;
	GTA *aut;
} checker_type;

typedef struct {
	GTA *descr,*from_shape;
} descriptor_type;


/*typedef struct {
	GTA **aut;
	int number;
} restrict_type;
*/

/* global variables shared betwean main and other modules */
extern unsigned NODE_WIDTH;

extern program_type *program;
extern GTA **state;
extern descriptor_type *descriptors;
extern checker_type *checkers;

extern int lines;
extern int descr;
extern int checkers_no;

extern Guide guide;
extern char *my_global_variable;
extern bdd_manager *global_bddm;

extern int abstr_length;


