#include <stdlib.h>
#include <stdio.h>
#include <string.h> 
#include "gta.h"
#include "../Mem/mem.h"
#include "main.h"

#define MAXVARS 1000

extern Guide guide;
extern char *my_global_variable;
extern bdd_manager *global_bddm;


GTA *apply_from_shape(GTA *init,GTA *transd) {
	unsigned *map,i;
	GTA *pp,*pp1;
	map=(unsigned *) mem_alloc(sizeof(unsigned)*((2*NODE_WIDTH)+4));	
	for (i=0; i<2*NODE_WIDTH; i=i+1) {
		map[i+4]=i;
	}
	pp1=gtaProduct(init,transd,gtaAND);
#ifdef VERBOSE
	printf("transducer applyed ...\n");
#endif
	pp=gtaMinimize(pp1); 
	gtaFree(pp1);
	//Projection
	pp1=gtaQuotientAndProject(pp,1,0);
	gtaFree(pp);
	pp=gtaQuotientAndProject(pp1,3,0);
	gtaFree(pp1);
#ifdef VERBOSE
	printf("Remapping...\n");
#endif
        gtaReplaceIndices(pp,map);
	pp1=gtaMinimize(pp); 
	/* leave memory free */
	mem_free(map);
	gtaFree(pp);
	return pp1;
}
