#include "gta.h"
#include "../Mem/mem.h"
#include "history_stack.h"


void histstack_init(hist_stack *s,int size) {
	//s->val=(hist_value *) mem_alloc(sizeof(hist_value)*(size));
	s->val=(hist_value *) malloc(sizeof(hist_value)*(size));
	s->no=-1;
	s->size=size;
}

void histstack_destroy(hist_stack *s) {
	//mem_free(s->val);
	free(s->val);
}
void histstack_reset(hist_stack *s) {
	int i;
	for (i=0;i<=s->no;i++) 
		if (s->val[i].state) gtaFree(s->val[i].state);
	s->no=-1;
}

hist_value histstack_pop(hist_stack *s) {
	hist_value ret;
	if (s->no<0) {
		ret.line=-1;
		ret.order=0;
		ret.state=NULL;
		return ret;
	}
	s->no--;
	return s->val[s->no+1];
}

void histstack_push(hist_stack *s,hist_value val) {
	/* realocate stack in case of reached limit */
	if (s->no>=s->size-1) {
		//s->val=(hist_value *) mem_resize(s->val, sizeof(hist_value)*(s->size+HSTACK_ALLOC_STEP));
		s->val=(hist_value *) realloc(s->val, sizeof(hist_value)*(s->size+HSTACK_ALLOC_STEP));
		s->size=s->size+HSTACK_ALLOC_STEP;
	}
	s->no++;
	s->val[s->no]=val;
}

int histstack_empty(hist_stack s) {
	if (s.no==-1) return 1;
	return 0;
}


