#include "gta.h"
#include "../Mem/mem.h"
#include "stack.h"


void stack_init(stack *s,int size) {
	s->val=(int *) mem_alloc(sizeof(int)*(size));
	s->no=-1;
	s->size=size;
}

void stack_destroy(stack *s) {
	mem_free(s->val);
}

int stack_pop(stack *s) {
	if (s->no<0) return -1;
	s->no--;
	return s->val[s->no+1];
}

int stack_push(stack *s,int val) {
	/* realocate stack in case of reached limit */
	if (s->no>=s->size-1) {
		s->val=(int *) mem_resize(s->val, sizeof(int)*(s->size+50));
		s->size=s->size+50;
	}
	s->no++;
	s->val[s->no]=val;
	return 1;
}

int stack_contains(stack s, int val) {
	int i;
	for(i=0;i<=s.no;i++) {
		if (s.val[i]==val) return 1;
	}
	return 0;
}
	
int stack_empty(stack s) {
	if (s.no==-1) return 1;
	return 0;
}

/******************************************************************/
/* same functions for unsigned                                    */
/******************************************************************/

void Ustack_init(Ustack *s,int size) {
	s->val=(unsigned *) mem_alloc(sizeof(unsigned)*(size));
	s->no=-1;
	s->size=size;
}

void Ustack_destroy(Ustack *s) {
	mem_free(s->val);
}

unsigned Ustack_pop(Ustack *s) {
	if (s->no<0) return -1;
	s->no--;
	return s->val[s->no+1];
}

int Ustack_push(Ustack *s,unsigned val) {
	/* realocate stack in case of reached limit */
	if (s->no>=s->size-1) {
		s->val=(unsigned *) mem_resize(s->val, sizeof(unsigned)*(s->size+50));
		s->size=s->size+50;
	}
	s->no++;
	s->val[s->no]=val;
	return 1;
}

int Ustack_contains(Ustack s, unsigned val) {
	int i;
	for(i=0;i<=s.no;i++) {
		if (s.val[i]==val) return 1;
	}
	return 0;
}
	
int Ustack_empty(Ustack s) {
	if (s.no==-1) return 1;
	return 0;
}
