#include "gta.h"
#include "../Mem/mem.h"
#include "var_pred_stack.h"


void varpredstack_init(varpred_stack *s,int size) {
	s->val=(var_pred *) malloc(sizeof(var_pred)*(size));
	s->no=-1;
	s->size=size;
}

void varpredstack_destroy(varpred_stack *s) {
	free(s->val);
}
void varpredstack_reset(varpred_stack *s) {
	int i;
	for (i=0;i<=s->no;i++) { 
		if (s->val[i].name) mem_free(s->val[i].name);
		if (s->val[i].decr) gtaFree(s->val[i].decr);
		if (s->val[i].inc) gtaFree(s->val[i].inc);
		if (s->val[i].eq) gtaFree(s->val[i].eq);
	}
	s->no=-1;
}

var_pred varpredstack_pop(varpred_stack *s) {
	var_pred ret;
	if (s->no<0) {
		ret.name=NULL;
		ret.decr=NULL;
		ret.inc=NULL;
		ret.eq=NULL;
		return ret;
	}
	s->no--;
	return s->val[s->no+1];
}

void varpredstack_push(varpred_stack *s,var_pred val) {
	/* realocate stack in case of reached limit */
	if (s->no>=s->size-1) {
		s->val=(var_pred *) realloc(s->val, sizeof(var_pred)*(s->size+VPSTACK_ALLOC_STEP));
		s->size=s->size+VPSTACK_ALLOC_STEP;
	}
	s->no++;
	s->val[s->no]=val;
}

int varpredstack_empty(varpred_stack s) {
	if (s.no==-1) return 1;
	return 0;
}


