#include "gta.h"
#include "../Mem/mem.h"
#include "var_stack.h"


void varstack_init(var_stack *s,int size) {
	/* s->val=(variant *) mem_alloc(sizeof(variant)*(size)); */
	s->val=(variant *) malloc(sizeof(variant)*(size));
	s->no=-1;
	s->size=size;
}

void varstack_destroy(var_stack *s) {
	//mem_free(s->val);
	free(s->val);
}
void varstack_reset(var_stack *s) {
	int i;
	for (i=0;i<=s->no;i++) 
		if (s->val[i].var) gtaFree(s->val[i].var);
	s->no=-1;
}

variant varstack_pop(var_stack *s) {
	variant ret;
	if (s->no<0) {
		ret.line_from=-1;
		ret.line_to=-1;
		ret.var=NULL;
		return ret;
	}
	s->no--;
	return s->val[s->no+1];
}

void varstack_push(var_stack *s,variant val) {
	/* realocate stack in case of reached limit */
	if (s->no>=s->size-1) {
		//s->val=(variant *) mem_resize(s->val, sizeof(variant)*(s->size+VSTACK_ALLOC_STEP));
		s->val=(variant *) realloc(s->val, sizeof(variant)*(s->size+VSTACK_ALLOC_STEP));
		s->size=s->size+VSTACK_ALLOC_STEP;
	}
	s->no++;
	s->val[s->no]=val;
}

int varstack_empty(var_stack s) {
	if (s.no==-1) return 1;
	return 0;
}


