#!/bin/sh
PROJECT_PATH=/homes/kazi/rogalew/Experiments/ARTMC-distr-2

#---------------------------------
# path to the JRE executable (java 1.5 or higher)
JRE_PATH=`which java`

#JRE_PATH="/local/jdk1.5.0_12/bin/java"
#JRE_PATH=/usr/bin/java5

# Project program (projection of mona tree automata)
PROJECT="$PROJECT_PATH/generator_gta/generator_main/automata_operations/project"
# Base directory
PARSER_HOME="$PROJECT_PATH/parser"

#----------------------------------
# The mona source code is necessary to build the executables from the source code
MONA="/homes/kazi/rogalew/Experiments/tools/mona-1.4"

#-----------------------------------------------
# this is a script template, script run set_project_path.sh in the main folder first


#------------------------------------
# compile artmc executables
echo "Compiling ARTMC executables (there may be few warnings, but NO ERROR) ..."
export MONA
cd "$PROJECT_PATH/artmc-main"

sh compile-main2-force-fin-height.sh
sh compile-main2-force-neighbour.sh
sh compile-main2-force-predicates.sh
echo "... done"

#------------------------------------
echo "Compiling auxionary executables ..."
cd  "$PROJECT_PATH/generator_gta/generator_main/automata_operations"
sh compile_get_transd_source.sh  
sh compile_intersect.sh  
sh compile_invert.sh  
sh compile_project.sh  
sh compile_union.sh
echo "... done"

#-----------------------------------
# copy executables into bin folder
cd "$PROJECT_PATH/"
cp artmc-main/main2-* bin
