#!/bin/sh
PROJECT_PATH=/homes/kazi/rogalew/Experiments/ARTMC-distr-2

#---------------------------------
# path to the JRE executable (java 1.5 or higher)
JRE_PATH=`which java`

#JRE_PATH="/local/jdk1.5.0_12/bin/java"
#JRE_PATH=/usr/bin/java5

# Project program (projection of mona tree automata)
PROJECT="$PROJECT_PATH/generator_gta/generator_main/automata_operations/project"
# Base directory
PARSER_HOME="$PROJECT_PATH/parser"

#----------------------------------
# The mona source code is necessary to build the executables from the source code
MONA="/homes/kazi/rogalew/Experiments/tools/mona-1.4"

#-----------------------------------------------
#this is a script template, use script set_project_path.sh first

if [ $[ $# < 4 ] == 1 ]; then
echo "USAGE: parse_c_code.t.sh c-file function_name handle_data ignore_array_assgn"
echo "handle_data: 1: YES, 0: NO (overapproximate)"
echo "ignore_array_assgn: 1: ignore (overapproximate), 0: stop parser when arrays are used"
exit
fi

# first parce .c input into clf file

echo "--------------------------------------"
echo "Parcing function $2 from $1"
echo "--------------------------------------"

$JRE_PATH -jar "$PROJECT_PATH/Averiles-C-parser/c2xml.jar" "$1" "$2";

if [ -f "$2_automaton.clf" ]; then
true
else
echo "---------------------------------"
echo "ERROR: file $2_automaton.clf not created by the parser..."
echo "... stoped"
exit
fi

echo "--------------------------------------"
echo ".c file parces."
echo "running clf -> ARTMC parcer"
echo "--------------------------------------"

#now we parse clf format into ARTMC inputs

if [ -f "typedefs" ]; then
true
else
echo "--------------------------------------"
echo "ERROR: provide typedefs to continue ..."
echo "... stoped"
exit
fi

DESC_NUM=`"$PROJECT_PATH/bin/get_typedef_descr.t.sh"`

$JRE_PATH -jar "$PROJECT_PATH/Averiles-C-parser/AverilesToARTMC_v5.jar" "$2_automaton.clf" "$3" "$4" "$DESC_NUM"

