#!/bin/sh
PROJECT_PATH=/homes/kazi/rogalew/Experiments/ARTMC-distr-2

#---------------------------------
# path to the JRE executable (java 1.5 or higher)
JRE_PATH=`which java`

#JRE_PATH="/local/jdk1.5.0_12/bin/java"
#JRE_PATH=/usr/bin/java5

# Project program (projection of mona tree automata)
PROJECT="$PROJECT_PATH/generator_gta/generator_main/automata_operations/project"
# Base directory
PARSER_HOME="$PROJECT_PATH/parser"

#----------------------------------
# The mona source code is necessary to build the executables from the source code
MONA="/homes/kazi/rogalew/Experiments/tools/mona-1.4"

#-----------------------------------------------
# this is templete of the script typedef_parse
# run the script "set_project_path.sh" in the main project directory

# ----------------------------------------------
echo "Creating backup of old initial files ..."
mv -f init.gta init.gta.old
for i in descr*; do
	mv -f $i $i.old
done
echo "----------------------------------------"

# Classpath
CLASSPATH=$PARSER_HOME/build/classes
export CLASSPATH


$JRE_PATH Main generate

# Project main
echo "Projecting init"
bits=`cat bit-init.gta`
for bit in $bits;
do
  mv init.gta init_tmp.gta
  $PROJECT init_tmp.gta $bit init.gta
  rm init_tmp.gta
done
echo


# Project descsriptors
for ((i=1;;i++)); 
do
  if [ ! -f bit-$i.gta ]; then
    break
  fi
  echo "Projecting descr-$i"
  bits=`cat  bit-$i.gta`
  for bit in $bits;
  do
    mv  descr-$i.gta  descr-${i}_tmp.gta
    $PROJECT  descr-${i}_tmp.gta  $bit  descr-$i.gta
    rm descr-${i}_tmp.gta
  done
  echo
done

#clean temporary files
rm -f bit-*.gta
