# Adam Rogalewicz
#
# This file contains generators of checkers to ensure, that left, right, and reverse retations are performable
#
# Use this given checker before the rotations

import functions

def gen_checker_right_rotate(x):
	table=[]
	bdd=[]  
	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,9,0))
	index=1
	#***********************************
	# left: 0 right:0
	# 00 -> 0
	# 01 -> 1
	table.append((0,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,index+3))
	bdd.append((-1,0,0))	
	bdd.append((-1,1,0))	
	index=index+4
	#***********************************
	# left: 0 right:1
	# left: 4 right:1
	# 01 -> 2
	table.append((0,1,index))
	table.append((4,1,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,2,0))	
	index=index+3
	#***********************************
	# left: 0 right:2
	# 01 -> 3
	table.append((0,2,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,3,0))	
	index=index+3
	#***********************************
	# left: 4 right:2
	# 01 -> 5
	table.append((4,2,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,5,0))	
	index=index+3
	#***********************************
	# left: 3 right:0
	# memory node
	# 1 x -> problem - unposiible to rotate => REJECT 
	# 1 ^x -> 4
	table.append((3,0,index))
	bdd.append((0,0,index+1))
	bdd.append((4+(2*x),index+2,0)) # <- goto reject state in case of 1
	bdd.append((-1,4,0))	
	index=index+3
	#***********************************
	# left: 5 right:0
	# memory node
	# 1 -> 4
	table.append((5,0,index))
	bdd.append((0,0,index+1))
	bdd.append((-1,4,0))	
	index=index+2
	#***********************************
	# left: 4 right:0
	# NULL pointers
	# 00 x -> problem - unposiible to rotate => REJECT 
	# 00 ^x -> 6
	table.append((4,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(2*x),index+3,0)) # <- goto reject state in case of 1
	bdd.append((-1,6,0))	
	index=index+4
	#***********************************
	# left: 6 right:0
	# NULL pointers
	# 00 x -> problem - unposiible to rotate => REJECT 
	# 00 ^x -> 7
	table.append((6,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(2*x),index+3,0)) # <- goto reject state in case of 1
	bdd.append((-1,7,0))	
	index=index+4
	#***************************************
	# left: 7 right:0
	# line number - nothin to check
	table.append((7,0,index))
	bdd.append((-1,8,0))# <- normally this will be an accepting state	
	index=index+1
	
	#return(bdd,table,[8])
	return(bdd,table,[9]) # <- we are searchinbg for bad configurations - "rejecting" state is accepting

def test_checker_right_rotate():
	(bdd,table,acc_list)=gen_checker_right_rotate(3)
	functions.gen_gta_file(bdd,table,acc_list,"test_check_right_rotate.gta")

#test_checker_right_rotate()


#---------------------------------------------------------------------
# check before left rotate
#---------------------------------------------------------------------

def gen_checker_left_rotate(x):
	table=[]
	bdd=[]  
	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,10,0))
	index=1
	#***********************************
	# left: 0 right:0
	# 00 -> 0
	# 01 -> 1
	table.append((0,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,index+3))
	bdd.append((-1,0,0))	
	bdd.append((-1,1,0))	
	index=index+4
	#***********************************
	# left: 0 right:1
	# 01 -> 2
	table.append((0,1,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,2,0))	
	index=index+3
	#***********************************
	# left: 4 right:1
	# 01 -> 2
	table.append((4,1,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,5,0))	
	index=index+3
	#***********************************
	# left: 0 right:2
	# left: 4 right:2
	# 01 -> 3
	table.append((0,2,index))
	table.append((4,2,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,3,0))	
	index=index+3
	#***********************************
	# left: 0 right:5
	# left: 4 right:5
	# 01 -> 6
	table.append((0,5,index))
	table.append((4,5,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,6,0))	
	index=index+3
	#***********************************
	# left: 6 right:0
	# memory node
	# 1 -> 4
	table.append((6,0,index))
	bdd.append((0,0,index+1))
	bdd.append((-1,4,0))	
	index=index+2
	#***********************************
	# left: 3 right:0
	# memory node
	# 1 x -> problem - unposiible to rotate => REJECT 
	# 1 ^x -> 4
	table.append((3,0,index))
	bdd.append((0,0,index+1))
	bdd.append((4+(2*x),index+2,0)) # <- goto reject state in case of 1
	bdd.append((-1,4,0))	
	index=index+3
	#***********************************
	# left: 4 right:0
	# NULL pointers
	# 00 x -> problem - unposiible to rotate => REJECT 
	# 00 ^x -> 7
	table.append((4,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(2*x),index+3,0)) # <- goto reject state in case of 1
	bdd.append((-1,7,0))	
	index=index+4
	#***********************************
	# left: 7 right:0
	# NULL pointers
	# 00 x -> problem - unposiible to rotate => REJECT 
	# 00 ^x -> 7
	table.append((7,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(2*x),index+3,0)) # <- goto reject state in case of 1
	bdd.append((-1,8,0))	
	index=index+4
	#***************************************
	# left: 8 right:0
	# line number - nothin to check
	table.append((8,0,index))
	bdd.append((-1,9,0))# <- normally this will be an accepting state	
	index=index+1
	
	#return(bdd,table,[9])
	return(bdd,table,[10]) # <- we are searchinbg for bad configurations - "rejecting" state is accepting

def test_checker_left_rotate():
	(bdd,table,acc_list)=gen_checker_left_rotate(3)
	functions.gen_gta_file(bdd,table,acc_list,"test_check_left_rotate.gta")

#test_checker_left_rotate()

