# Adam Rogalewicz
#
# This file contains generator of a transducers for repair of the tree structure after the rotations
# - we suppose 3 next pointers, left, right, and up


import functions
import sys

def gen_repare(node_width, pointer_num, line_orig, line_goto):

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,3,0))
	index=1



	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the third pointer descriptor - UP (01)
	#****************************************
	table.append((0,0,1))
	bdd.append((0,2,0))#1 -- the first bit of the type of the input node
	bdd.append((1,3,0))#2 -- the first bit of the type of the output node
	bdd.append((2,4,6))#3 -- if 1, we found the 1st pointer descriptor => go to line 9
	bdd.append((3,5,0))#4
	bdd.append((-1,0,0))#5 -- 00(0,0) -> 00, finished / note that 0 is a state, 00 an input symbol
	index=index+5
	
	bdd.append((3,0,index+1))
	index=index+1
	# destinguis between 01010, and 011001
	# we don't care about input symbol, we just write directly the output
	bdd.append((5,index+1,index+4))
	bdd.append((7,0,index+2))
	bdd.append((9,index+3,0))
	bdd.append((-1,2,0)) #01010
	index=index+4
	bdd.append((7,index+1,0))
	bdd.append((9,index+2,0))
	bdd.append((11,0,index+3))
	bdd.append((-1,1,0)) #011001
	index=index+4

	#**************************************
	# left:0 right: 1
	# - second pointer descriptor
	# - nothing under it
	# - set it to 01010 = NULL
	#**************************************
	table.append((0,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,index+5,0))
	bdd.append((7,0,index+6))
	bdd.append((9,index+7,0))
	bdd.append((-1,11,0))
	index=index+8
	#**************************************
	# left:0 right: 2
	# - second pointer descriptor
	# - nothing under it
	# - set it to 01010 = NULL
	#**************************************
	table.append((0,2,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,index+5,0))
	bdd.append((7,0,index+6))
	bdd.append((9,index+7,0))
	bdd.append((-1,12,0))
	index=index+8
	#**************************************
	# left:0 right: 11
	# - first pointer descriptor
	# - nothing under it
	# - set it to 01010 = NULL
	#**************************************
	table.append((0,11,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,index+5,0))
	bdd.append((7,0,index+6))
	bdd.append((9,index+7,0))
	bdd.append((-1,16,0))
	index=index+8
	#**************************************
	# left:0 right: 12
	# - first pointer descriptor
	# - nothing under it
	# - set it to 01010 = NULL
	#**************************************
	table.append((0,12,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,index+5,0))
	bdd.append((7,0,index+6))
	bdd.append((9,index+7,0))
	bdd.append((-1,17,0))
	index=index+8
	#**************************************
	# left:6 right: 1
	# - second pointer descriptor
	# - internal leaf
	# - set it to 011010 = rightdown
	#**************************************
	table.append((6,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,0,index+5))
	bdd.append((7,index+6,0))
	bdd.append((9,0,index+7))
	bdd.append((11,index+8,0))
	bdd.append((-1,11,0))
	index=index+9
	#**************************************
	# left:6 right: 2
	# - second pointer descriptor
	# - internal leaf
	# - set it to 011010 = rightdown
	#**************************************
	table.append((6,2,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,0,index+5))
	bdd.append((7,index+6,0))
	bdd.append((9,0,index+7))
	bdd.append((11,index+8,0))
	bdd.append((-1,12,0))
	index=index+9
	#**************************************
	# left:6 right: 11
	# - second pointer descriptor
	# - internal leaf
	# - set it to 011100 = leftdown
	#**************************************
	table.append((6,11,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,0,index+5))
	bdd.append((7,0,index+6))
	bdd.append((9,index+7,0))
	bdd.append((11,index+8,0))
	bdd.append((-1,16,0))
	index=index+9
	#**************************************
	# left:6 right: 12
	# - second pointer descriptor
	# - internal leaf
	# - set it to 011100 = leftdown
	#**************************************
	table.append((6,12,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((5,0,index+5))
	bdd.append((7,0,index+6))
	bdd.append((9,index+7,0))
	bdd.append((11,index+8,0))
	bdd.append((-1,17,0))
	index=index+9
	#**************************************
	# left:16 right: 0
	# - inner memory node
	#**************************************
	table.append((16,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	bdd.append((3,index+3,0)) # don't care about input
	index=index+3
	# copy pointer variables
	(bdd,index)=functions.copy_n_elements(bdd,index,pointer_num,4)
	# set token to 0
	bdd.append((5+(2*pointer_num),index+1,0))
	# there is only one marker set in all memory nodes = we use exact descriptors
	bdd.append((7+(2*pointer_num),0,index+2))
	index=index+2
	# copy data value (if exist)
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(4+pointer_num),8+(2*pointer_num))
	bdd.append((-1,6,0))
	index=index+1

	#**************************************
	# left:17 right: 0
	# - top memory node
	#**************************************
	table.append((17,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	bdd.append((3,0,index+3)) # don't care about input
	index=index+3
	# copy pointer variables
	(bdd,index)=functions.copy_n_elements(bdd,index,pointer_num,4)
	# set token to 0
	bdd.append((5+(2*pointer_num),index+1,0))
	# there is only one marker set in all memory nodes = we use exact descriptors
	bdd.append((7+(2*pointer_num),0,index+2))
	index=index+2
	# copy data value (if exist)
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(4+pointer_num),8+(2*pointer_num))
	bdd.append((-1,7,0))
	index=index+1

	#**************************************
	# left:7 right: 0
	# - null pointers
	#**************************************
	table.append((7,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,pointer_num,4)
	bdd.append((-1,8,0))
	index=index+1
	#**************************************
	# left:8 right: 0
	# - undef pointers
	#**************************************
	table.append((8,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,pointer_num,4)
	bdd.append((-1,9,0))
	index=index+1
	#**************************************
	# left:9 right: 0
	# - line number - JUST COPY
	#**************************************
	table.append((9,0,index))
	(bdd,index)=functions.change_line_num(bdd,index,line_orig,line_goto)
	bdd.append((-1,10,0)) # accept
	index=index+1
	
	return(bdd,table,[10])
	
def test_gen_repare():
	(bdd,table,acc_list)=gen_repare(12,7,"00000001","00000001")
	functions.gen_gta_file(bdd,table,acc_list,"test_repare.gta")


#test_gen_repare()

def repare_after_new(node_width, x):
	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,7,0))
	index=1
	
	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the third pointer descriptor - UP (01)
	#  output: not changed - 1, repared - 2
	#****************************************
	table.append((0,0,1))
	bdd.append((0,2,0))#1 -- the first bit of the type of the input node
	bdd.append((1,3,0))#2 -- the first bit of the type of the output node
	bdd.append((2,4,6))#3 -- if 1, we found the 1st pointer descriptor => go to line 9
	bdd.append((3,5,0))#4
	bdd.append((-1,0,0))#5 -- 00(0,0) -> 00, finished / note that 0 is a state, 00 an input symbol
	index=index+5
	
	bdd.append((3,0,index+1))
	index=index+1
	bdd.append((4,-1,index+1))
	aux=index
	# pointer descriptor UP is defined
	bdd.append((5,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-3,6)
	bdd.append((-1,1,0))
	index=index+1
	# null/undefined
	bdd[aux]=(4,index,bdd[aux][2])
	bdd.append((5,index+1,index+7)) # nondeterministich choice  - repare/leave
	bdd.append((6,0,index+2)) 
	bdd.append((7,0,index+3))
	bdd.append((8,index+4,index+5))
	bdd.append((9,index+6,0))
	bdd.append((9,0,index+6))
	index=index+7
	bdd.append((-1,1,0))
	# place descriptor 1UP here
	bdd.append((7,index+1,0))
	bdd.append((9,index+2,0))
	bdd.append((11,0,index+3))
	bdd.append((-1,2,0))
	index=index+4
	
	#****************************************
	# left: 0 right:1
	# left: 6 right:1
	# 01 - pointer node
	#****************************************
	table.append((0,1,index))
	table.append((6,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	
	#****************************************
	# left: 0 right:2
	# second pointer descriptor - before: 01011, after: 01010 = NULL
	# output: 3 - node repared
	#****************************************
	table.append((0,2,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((4,index+5,0))
	bdd.append((5,index+6,0))
	bdd.append((6,0,index+7))
	bdd.append((7,0,index+8))
	bdd.append((8,0,index+9))
	bdd.append((9,index+10,0))
	bdd.append((-1,3,0))
	index=index+11
	#****************************************
	# left: 0 right:3
	# first pointer descriptor - before: 01011, after: 01010 = NULL
	# output: 4 - node repared
	#****************************************
	table.append((0,3,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	bdd.append((4,index+5,0))
	bdd.append((5,index+6,0))
	bdd.append((6,0,index+7))
	bdd.append((7,0,index+8))
	bdd.append((8,0,index+9))
	bdd.append((9,index+10,0))
	bdd.append((-1,4,0))
	index=index+11
	
	#****************************************
	# left: 4 right:0
	# 10 - memory node
	#****************************************
	table.append((4,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	bdd.append((2,index+3,0))
	bdd.append((3,index+4,0))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,5,0))
	index=index+1
	#****************************************
	# left: 5 right:1
	# left: 6 right:5
	# left: 0 right:5
	# 01 - pointer node
	#****************************************
	table.append((5,1,index))
	table.append((6,5,index))
	table.append((0,5,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,5,0))
	index=index+1
	#****************************************
	# left: 5 right:0
	# check x - output: 1, otherwice reject
	# 1x - memory node
	#****************************************
	table.append((5,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_n_elements_check_x(bdd,index,node_width-1,2,x+1)
	bdd.append((-1,6,0))
	index=index+1
	#****************************************
	# left: 1 right:0
	# check NOT(x) - output: 6, otherwice reject
	# 1x - memory node
	#****************************************
	table.append((1,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,node_width-1,2,x+1,0)
	bdd.append((-1,6,0))
	index=index+1
	
	#****************************************
	# left: 6 right:0
	# null/undef pointers (00), line number (XXXXX)
	# output: 6
	# This is just a copying node
	#****************************************
	table.append((6,0,index))
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,6,0))
	index=index+1
	return(bdd,table,[6])
	

def test_repare_after_new():
	(bdd,table,acc_list)=repare_after_new(7,1)
	functions.gen_gta_file(bdd,table,acc_list,"repare_after_new.gta")

#test_repare_after_new()
