# Adam Rogalewicz
#
import functions

def prepare_right_rot_back(node_width,pointer_num,x):

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,8,0))
	index=1

	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the pointer descriptor  (01)
	#****************************************
	table.append((0,0,1))
	bdd.append((0,2,0))#1 -- the first bit of the type of the input node
	bdd.append((1,3,0))#2 -- the first bit of the type of the output node
	bdd.append((2,4,6))#3 -- if 1, we found the 1st pointer descriptor => go to line 9
	bdd.append((3,5,0))#4
	bdd.append((-1,0,0))#5 -- 00(0,0) -> 00, finished / note that 0 is a state, 00 an input symbol
	index=index+5

	bdd.append((3,0,index+1))
	index=index+1
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	
	#***********************************************
	# left: 0 right: 1
	# left: 1 right: 1
	# - pointer descriptor
	#***********************************************
	table.append((0,1,index))
	table.append((1,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	#*******************************************
	# left: 1 right: 0
	# - 1: memory node
	# - 00: null pointers
	#***********************************************
	table.append((1,0,index))
	bdd.append((0,index+1,-2))
	aux=index
	# null pointers
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0))
	bdd.append((3,index+4,0))
	index=index+4
	#(bdd,index)=functions.copy_n_elements(bdd,index,pointer_num,4)
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,pointer_num,4,x,0)
	bdd.append((-1,5,0))
	index=index+1
	# memory node
	bdd[aux]=(0,bdd[aux][1],index)
	bdd.append((1,0,index+1))
	index=index+1
	# we set token to the value of x, and return state dependentely on x
	# x=0 ... ret 1
	# x=1 ... ret 2
	# NOTE: we start copying with the second bit - the identificator -> therefore token=pointer_num+1, "x"=x+1
	#(bdd,index)=functions.copy_node_Ret_st_dep_on_y_Set_x_to_y(bdd,index,node_width-1,2,pointer_num+1,x+1,1,2)
	(bdd,index)=functions.copy_node_return_state_dep_on_x(bdd,index,node_width-1,2,x+1,1,2)
	
	#*******************************************
	# left: 2 right: 1
	# - 01: second !!! pointer descriptor
	#***********************************************
	table.append((2,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,3,0))
	index=index+1
	#*******************************************
	# left: 1 right: 3
	# left: 0 right: 3
	# - 01: first !!! pointer descriptor
	#***********************************************
	table.append((1,3,index))
	table.append((0,3,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,4,0))
	index=index+1
	#*******************************************
	# left: 4 right: 0
	# - 1: memory node
	#***********************************************
	table.append((4,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	index=index+2
	# set token !!!
	(bdd,index)=functions.copy_n_elements_set_x(bdd,index,node_width-1,2,pointer_num+1)
	bdd.append((-1,1,0))
	index=index+1
	#*******************************************
	# left: 5 right: 0
	# 00 - undefined pointers
	#***********************************************
	table.append((5,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0))
	bdd.append((3,index+4,0))
	index=index+4
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,pointer_num,4,x,0)
	bdd.append((-1,6,0))
	index=index+1
	#*******************************************
	# left: 6 right: 0
	# line number - just copy
	#***********************************************
	table.append((6,0,index))
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,7,0))
	index=index+1

	return(bdd,table,[7])
	
def test_rot_back():
	(bdd,table,acc_list)=prepare_right_rot_back(11,4,3)
	functions.gen_gta_file(bdd,table,acc_list,"test_rot_back_right.gta")


#test_rot_back()
	
	
	
#-----------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------
# LEFT ROTATION
#-----------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------
	
	
def prepare_left_rot_back(node_width,pointer_num,x):

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,8,0))
	index=1

	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the pointer descriptor  (01)
	#****************************************
	table.append((0,0,1))
	bdd.append((0,2,0))#1 -- the first bit of the type of the input node
	bdd.append((1,3,0))#2 -- the first bit of the type of the output node
	bdd.append((2,4,6))#3 -- if 1, we found the 1st pointer descriptor => go to line 9
	bdd.append((3,5,0))#4
	bdd.append((-1,0,0))#5 -- 00(0,0) -> 00, finished / note that 0 is a state, 00 an input symbol
	index=index+5

	bdd.append((3,0,index+1))
	index=index+1
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	
	#***********************************************
	# left: 0 right: 1
	# left: 1 right: 1
	# - pointer descriptor
	#***********************************************
	table.append((0,1,index))
	table.append((1,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	#*******************************************
	# left: 1 right: 0
	# - 1: memory node
	# - 00: null pointers
	#***********************************************
	table.append((1,0,index))
	bdd.append((0,index+1,-2))
	aux=index
	# null pointers
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0))
	bdd.append((3,index+4,0))
	index=index+4
	#(bdd,index)=functions.copy_n_elements(bdd,index,pointer_num,4)
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,pointer_num,4,x,0)
	bdd.append((-1,5,0))
	index=index+1
	# memory node
	bdd[aux]=(0,bdd[aux][1],index)
	bdd.append((1,0,index+1))
	index=index+1
	# we set token to the value of x, and return state dependentely on x
	# x=0 ... ret 1
	# x=1 ... ret 2
	# NOTE: we start copying with the second bit - the identificator -> therefore token=pointer_num+1, "x"=x+1
	#(bdd,index)=functions.copy_node_Ret_st_dep_on_y_Set_x_to_y(bdd,index,node_width-1,2,pointer_num+1,x+1,1,2)
	(bdd,index)=functions.copy_node_return_state_dep_on_x(bdd,index,node_width-1,2,x+1,1,2)
	#*******************************************
	# left: 2 right: 1
	# - 01: first !!! pointer descriptor
	#***********************************************
	table.append((2,1,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,4,0))
	index=index+1
	#*******************************************
	# left: 4 right: 0
	# - 1: memory node
	#***********************************************
	table.append((4,0,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	index=index+2
	# set token !!!
	(bdd,index)=functions.copy_n_elements_set_x(bdd,index,node_width-1,2,pointer_num+1)
	bdd.append((-1,1,0))
	index=index+1
	#*******************************************
	# left: 5 right: 0
	# 00 - undefined pointers
	#***********************************************
	table.append((5,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0))
	bdd.append((3,index+4,0))
	index=index+4
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,pointer_num,4,x,0)
	bdd.append((-1,6,0))
	index=index+1
	#*******************************************
	# left: 6 right: 0
	# line number - just copy
	#***********************************************
	table.append((6,0,index))
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,7,0))
	index=index+1

	return(bdd,table,[7])

def test_rot_left_back():
	(bdd,table,acc_list)=prepare_left_rot_back(11,4,3)
	functions.gen_gta_file(bdd,table,acc_list,"test_rot_back_left.gta")


#test_rot_left_back()
	
