/* gta_example.c - GTA package example dummy application */

/*
 * MONA
 * Copyright (C) 1997-2002 BRICS.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the  Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h> 
#include "gta.h"

#define MAXVARS 1000

Guide guide;

char *my_global_variable;
bdd_manager *global_bddm;

int main (int argc,char **argv) {
	int i,limit;
	GTA *a1,*a2,*res;
	char **free_vars;
	int *orders; 
	unsigned numvars;
	SSSet *statespaces;
	if (argc<4) {
		printf("To few arguments\n");
		return 1;
	}
	sscanf(argv[3],"%i",&limit);
  	a1 = gtaImport(argv[1], &free_vars, &orders, &statespaces, TRUE);
	if(!a1) {
		printf("error: Chyba nacitani souboru %s!!!!\n",argv[1]);
		exit(1);
	}
	for(i=1;i<=limit;i=i+2) {
		printf("projecting track %i\n",i);
		a2=gtaQuotientAndProject(a1,i,0);
                gtaFree(a1);
                a1=a2;
        }
	res=gtaMinimize(a1);
  	gtaExport(res,argv[2], 2,free_vars, orders, statespaces, 0);
  return 0;
}
