import functions

def line_num_checker(line_prefix,file_name):
	# line prefix is a string.
	# e.g. "10xx1" is generate checker which detects a tree with line number of 
	# beginning with "10xx1", where x = do not care
	bdd=[]
	table=[]
	# there are two states
	# 0 - node without prefix "line_prefix" is read
	# 1 - node with prefix "line_prefix" is read - accept

	bdd.append((-1,0,0))#0
	index=1
	table.append((0,0,index))
	table.append((1,0,index))
	table.append((0,1,index))
	table.append((1,1,index))

	for i in range(len(line_prefix)):
		if line_prefix[i]=="0":
			bdd.append((i*2,index+1,0))
			index=index+1
		if line_prefix[i]=="1":
			bdd.append((i*2,0,index+1))
			index=index+1
		# for the case of something else then 1, or 0, we skip this bit
	bdd.append((-1,1,0))
	index=index+1
	functions.gen_gta_file(bdd,table,[1],file_name)


def delete_node_checker(pointer_num,file_name):
	# this checker searches for memory nodes of the type 1x1__1_
	# Where ___1_ is the string describing pointer variables pointing to the memoty node
	# -> i.e. error is in case when a pointer variable is aliased to the deleted node
	bdd=[]
	table=[]
	# states
	# 0 - init (only "00" leaves)
	# 1 - processing of the tree - no error
	# 2 - processing of the tree - error discovered
	# 3 - end of process of the tree - accept
	# 4 - reject
	bdd.append((-1,4,0))# reject
	index=1
	# input states: (0,0)
	# "00" -> 0
	# "01" -> 1
	table.append((0,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,index+3))
	bdd.append((-1,0,0)) # bottom node (00)
	bdd.append((-1,1,0)) # first pointer descriptor read
	index=index+4
	# input states: (1,0) (0,1) (1,1)
	# "01" -> 1
	# "1x1__1__ -> 2
	# "1x100000 -> 1

	table.append((1,0,index))
	table.append((0,1,index))
	table.append((1,1,index))
	bdd.append((0,index+1,index+4))
	bdd.append((2,0,index+2))
	bdd.append((-1,1,0)) # pointer descriptor node
	index=index+3
	bdd.append((-1,2,0))
	out2=index
	bdd.append((4,index+2,index+3))
	bdd.append((-1,1,0)) # non deleted node
	index=index+3
	for i in range(pointer_num-1):
		bdd.append((6+(2*i),index+1,out2))
		index=index+1
	bdd.append((-1,1,0))
	index=index+1
	
	# input states: (2,0) (0,2) (2,2) (2,1) (1,2)
	# 1 -> 2
	# 00 -> 3
	# 01 -> 2
	table.append((2,0,index))
	table.append((0,2,index))
	table.append((2,2,index))
	table.append((2,1,index))
	table.append((1,2,index))
	bdd.append((0,index+2,index+1))
	bdd.append((-1,2,0)) #1x/01
	bdd.append((2,index+3,index+1))
	bdd.append((-1,3,0)) #1x/01
	index=index+4
	
	# input states (3,0)
	# -> 3 (read undefine pointers and line number
	table.append((3,0,index))
	bdd.append((-1,3,0))
	index=index+1
	functions.gen_gta_file(bdd,table,[3],file_name)
