import functions
import sys


def free(node_width, x, line_orig, line_goto):
	'''free (x)'''

# node_width  -- maximal size of a tree node (number of bits)
# x           -- the number of the pointer aliased to the node setting to deleted

# line_orig and line_goto must be of the same length equal to the maximum length possible!

# We use the following states in the transducer:
#   0 - processing of the tree
#   1 - read top
#   2 - read null - status OK
#   3 - read null - status Error (x = null)
#   4 - read undef - status OK
#   5 - read undef - status Error (x = null/undefined
#   6 - accept
#   7 - reject

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)
	

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,7,0))#0
	index=1

       	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the pointer descriptor (01)
	#   - inner memory node (10)
	#   - top memory node (11)
	#****************************************
	table.append((0,0,index))
	bdd.append((0,index+1,-2))
	aux=index
	# pointer node / initial node - just copy
	bdd.append((1,index+2,0))
	index=index+2
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-1,2)
	bdd.append((-1,0,0))
	index=index+1
	# memory node
	bdd[aux]=(0,bdd[aux][1],index)
	bdd.append((1,0,index+1))
	# check, whether we are top/inner memory node
	bdd.append((2,index+2,-2))
	aux=index+1
	#-----------------
	#inner memory node
	bdd.append((3,index+3,0))
	index=index+3
	# if disposed => just copy
	bdd.append((4,-2,index+1))
	aux2=index
	bdd.append((5,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-3,6)
	bdd.append((-1,0,0))
	index=index+1
	# guess whether x points into this node and set/not set "disposed mark"
	bdd[aux2]=(4,index,bdd[aux2][2])
	bdd.append((5,index+1,-2))
	aux2=index
	index=index+1
	# check that x does not point into this node
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,node_width-3,6,x-1,0)
	bdd.append((-1,0,0))
	index=index+1
	# check that x is present and unset it
	bdd[aux2]=(5,bdd[aux2][1],index)
	(bdd,index)=functions.copy_node_return_state_dep_on_x_unset_y(bdd,index,node_width-3,6,x-1,x-1,7,0)
	#----------------
	#top memory node
	bdd[aux]=(2,bdd[aux][1],index)
	bdd.append((3,0,index+1))
	index=index+1
	top_bdd=index
	# if disposed => just copy
	bdd.append((4,-2,index+1))
	aux2=index
	bdd.append((5,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-3,6)
	bdd.append((-1,1,0))
	index=index+1
	# guess whether x points into this node and set "disposed mark"
	bdd[aux2]=(4,index,bdd[aux2][2])
	bdd.append((5,index+1,-2))
	aux2=index
	index=index+1
	# check that x does not point into this node
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,node_width-3,6,x-1,0)
	bdd.append((-1,1,0))
	index=index+1
	# check that x is present and unset it
	bdd[aux2]=(5,bdd[aux2][1],index)
	(bdd,index)=functions.copy_node_return_state_dep_on_x_unset_y(bdd,index,node_width-3,6,x-1,x-1,7,1)

	
	#****************************************
	# left state=0, right state=1:
	#   - a top memory node (11)
	#****************************************
	table.append((0,1,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	bdd.append((2,0,index+3)) 
	bdd.append((3,0,top_bdd)) 
	index=index+4


	#****************************************
	# left state=1, right state=0:
	#   - null pointer definition (00)
	#****************************************
	table.append((1,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index,patch_x_unset,patch_x_set)=functions.copy_n_elements_and_remember_x(bdd,index,node_width-2,4,x)
	for i in patch_x_unset:
		if i[1]==1:
			bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else:
			bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,2,0))
	index=index+1
	for i in patch_x_set:
		if i[1]==1:
			bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else:
			bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,3,0))
	index=index+1

	#****************************************
	# left state=2, right state=0:
	#   - undefined pointer definition (00)
	#****************************************
	table.append((2,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_node_return_state_dep_on_x_set_y(bdd,index,node_width-2,4,x,x,4,5)

	#****************************************
	# left state=3, right state=0:
	#   - undefined pointer definition - ERROR - just copy
	#****************************************
	table.append((3,0,index))
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,5,0))
	index=index+1


	# ****************************************
	# left state=4, right state=0:
	#  - a line number change 
	# ****************************************	
	table.append((4,0,index))	
	(bdd,index)=functions.change_line_num(bdd,index,line_orig,line_goto)
	bdd.append((-1,6,0)) # accept
	index=index+1

	# ****************************************
	# left state=4, right state=0:
	#  - a line number change 
	# ****************************************	
	table.append((5,0,index))	
	(bdd,index)=functions.change_line_num_to_err(bdd,index,line_orig)
	bdd.append((-1,6,0)) # accept
	index=index+1

	return(bdd,table,[6])

#--------------------------------------------------------------------------------
#  Prepare free - set a posinter variable y to undefined iff y==x 
# This transducer is generated for all pointer variables except x
#--------------------------------------------------------------------------------

def prepare_free(node_width , x, y):

# node_width  -- maximal size of a tree node (number of bits)
# x           -- the number of the pointer aliased to the node setting to deleted
# y           -- x!=y, we check whether y is alliased to the same node as x. If so, we set y to undefined.

# line_orig and line_goto must be of the same length equal to the maximum length possible!

# We use the following states in the transducer:
#   0 - processing of the tree x!=y (accept)
#   1 - processing of the tree x==y
#   2 - read null x==y
#   3 - read null x!=y
#   4 - read top x!=y
#   5 - read top x==y
#   6 - read undef
#   7 - accept
#   8 - reject

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)

	if x==y:
		print "Error: prepare_free: x==y"
		sys.exit()
	
	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.


	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,8,0))#0
	index=1

       	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the pointer descriptor (01)
	#   - inner memory node (10)
	#   - top memory node (11)
	#****************************************
	table.append((0,0,index))
	bdd.append((0,index+1,-2))
	aux=index
	# pointer node / initial node - just copy
	bdd.append((1,index+2,0))
	index=index+2
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-1,2)
	bdd.append((-1,0,0))
	index=index+1
	# memory node
	bdd[aux]=(0,bdd[aux][1],index)
	bdd.append((1,0,index+1))
	bdd.append((2,index+2,-2))
	aux2=index+1
	# inner memory node 10xxx
	bdd.append((3,index+3,0))
	index=index+3
	if x<y:
		(bdd,index)=functions.copy_n_elements(bdd,index,x,4)
		#now check x
		bdd.append((4+(2*x),index+1,-2))
		aux=index
		bdd.append((5+(2*x),index+2,0))
		index=index+2
		(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(3+x),(6+(2*x)))
		bdd.append((-1,0,0))
		index=index+1
		# the case, where x is set
		bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
		bdd.append((5+(2*x),0,index+1))
		index=index+1
		(bdd,index)=functions.copy_node_return_state_dep_on_x_unset_y(bdd,index,node_width-(3+x),(6+(2*x)),y-(x+1),y-(x+1),0,1)
	else:
		(bdd,index)=functions.copy_n_elements(bdd,index,y,4)
		#now check y
		bdd.append((4+(2*y),index+1,-2))
		aux=index
		bdd.append((5+(2*y),index+2,0))
		index=index+2
		(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(3+y),(6+(2*y)))
		bdd.append((-1,0,0))
		index=index+1
		# the case, where y is set
		bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
		#now, we need to guess, whether x is set, or not, and unset/preserve y
		bdd.append((5+(2*y),index+1,-2))
		aux=index
		index=index+1
		# we guess that x is set, so we need to check it
		(bdd,index)=functions.copy_n_elements_check_x(bdd,index,node_width-(3+y),(6+(2*y)),x-(y+1))
		bdd.append((-1,1,0))
		index=index+1
		#now, we guess that x is not se, so check it
		bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
		(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,node_width-(3+y),(6+(2*y)),x-(y+1),0)
		bdd.append((-1,0,0))
		index=index+1

	# top memory node (11)
	bdd[aux2]=(2,bdd[aux2][1],index)
	bdd.append((3,0,index+1))
	index=index+1
	process_top=index
	if x<y:
		(bdd,index)=functions.copy_n_elements(bdd,index,x,4)
		#now check x
		bdd.append((4+(2*x),index+1,-2))
		aux=index
		bdd.append((5+(2*x),index+2,0))
		index=index+2
		(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(3+x),(6+(2*x)))
		bdd.append((-1,4,0))
		index=index+1
		# the case, where x is set
		bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
		bdd.append((5+(2*x),0,index+1))
		index=index+1
		(bdd,index)=functions.copy_node_return_state_dep_on_x_unset_y(bdd,index,node_width-(3+x),(6+(2*x)),y-(x+1),y-(x+1),4,5)
	else:
		(bdd,index)=functions.copy_n_elements(bdd,index,y,4)
		#now check y
		bdd.append((4+(2*y),index+1,-2))
		aux=index
		bdd.append((5+(2*y),index+2,0))
		index=index+2
		(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(3+y),(6+(2*y)))
		bdd.append((-1,4,0))
		index=index+1
		# the case, where y is set
		bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
		#now, we need to guess, whether x is set, or not, and unset/preserve y
		bdd.append((5+(2*y),index+1,-2))
		aux=index
		index=index+1
		# we guess that x is set, so we need to check it
		(bdd,index)=functions.copy_n_elements_check_x(bdd,index,node_width-(3+y),(6+(2*y)),x-(y+1))
		bdd.append((-1,5,0))
		index=index+1
		#now, we guess that x is not set, so check it
		bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
		(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,node_width-(3+y),(6+(2*y)),x-(y+1),0)
		bdd.append((-1,4,0))
		index=index+1


       	#****************************************
	# left state=1, right state=0: 
	# left state=0, right state=1: 
	#   - the pointer descriptor (01)
	#   - inner memory node (10)
	#   - top memory node (11)
	#  case x==y
	#****************************************
	table.append((1,0,index))
	table.append((0,1,index))
	bdd.append((0,index+1,-2))
	aux=index
	# 01xxx - pointer descriptor - copy
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3))
	bdd.append((3,0,index+4))
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	# 1xxx  
	bdd[aux]=(0,bdd[aux][1],index)
	bdd.append((1,0,index+1))
	bdd.append((2,index+2,-2))
	aux=index+1
	bdd.append((3,index+3,0))
	index=index+3
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1
	# top memory node
	bdd[aux]=(2,bdd[aux][1],index)
	bdd.append((3,0,index+1))
	index=index+1
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,5,0))
	index=index+1

       	#****************************************
	# left state=0, right state=5: 
	# left state=1, right state=4: 
	#   - top memory node (11) x==y - copy
	#   - top memory node (11) x==y - copy
       	#****************************************
	table.append((0,5,index))
	table.append((1,4,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	bdd.append((2,0,index+3)) 
	bdd.append((3,0,index+4)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,5,0))
	index=index+1

       	#****************************************
	# left state=0, right state=4: 
	#   - top memory node (11) x!=y
       	#****************************************
	table.append((0,4,index))
	bdd.append((0,0,index+1))
	bdd.append((1,0,index+2))
	bdd.append((2,0,index+3)) 
	bdd.append((3,0,process_top)) 
	index=index+4


       	#****************************************
	# left state=5, right state=0: 
	#   - null pointers (00) x==y - copy
       	#****************************************
	table.append((5,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,2,0))
	index=index+1
       	#****************************************
	# left state=4, right state=0: 
	#   - null pointers (00) x!=y - copy
       	#****************************************
	table.append((4,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,3,0))
	index=index+1
       	#****************************************
	# left state=2, right state=0: 
	#   - undefined pointers (00) - set y
       	#****************************************
	table.append((2,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements_set_x(bdd,index,node_width-2,4,y)
	bdd.append((-1,6,0))
	index=index+1

       	#****************************************
	# left state=3, right state=0: 
	#   - undefined pointers (00) - copy
       	#****************************************
	table.append((3,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0)) 
	index=index+4
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,6,0))
	index=index+1
       	#****************************************
	# left state=6, right state=0: 
	#   - line number - copy
       	#****************************************
	table.append((6,0,index))
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,7,0))
	index=index+1

	return(bdd,table,[7])


#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_free_x():
	"""test free(x)"""
	(bdd,table,acc)=free(13,5,3,"00000001", "00000011")
	functions.gen_gta_file(bdd,table, acc,"free_x.gta")

	""" test prepare_free """
	(bdd,table,acc)=prepare_free(13,5,2,1)
	functions.gen_gta_file(bdd,table, acc,"prepare_free.gta")

#test_free_x()

#=================================================================================

