import functions
import sys


def goto(node_width, line_orig, line_goto):
	'''goto xy'''


# line_orig and line_goto must be of the same length equal to the maximum length possible!

# if line_orig & line_goto are equal, than this function is stoped, and error is reached

# We use the following states in the transducer:
#   0 - reading the init symbols
#   1 - line number changed - ACCEPT
#   2 - REJECT

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)
	

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,2,0))#0
	index=1
	aux=index
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-1,2)
	bdd.append((-1,0,0))
	index=index+1
       	table.append((0,0,index))
	if len(line_orig) >node_width:
		print "ERROR: line number is longer than node_width"
		sys.exit(1)
	if len(line_orig) != len(line_goto):
		print "ERROR: length of line nubers are not equal"
		sys.exit(1)
	if line_orig==line_goto:
		print "ERROR: line_orig==line_goto"
		sys.exit(1)
	change=0
	for i in range(len(line_orig)):
		if line_orig[i]=='1':
			if change:
				bdd.append((i*2,0,index+1))
				index=index+1
			else:
				bdd.append((i*2,index+1,index+2))
				bdd.append(((i*2)+1,aux+(i*3),0)) # skip to copying part
				index=index+2
			if line_goto[i]=='1':
				bdd.append(((i*2)+1,0,index+1))
				index=index+1
			else:
				if change:
					bdd.append(((i*2)+1,index+1,0))
				else:
					bdd.append(((i*2)+1,index+1,aux+(i*3)))
					change=1
				index=index+1
		else:
			if change:
				bdd.append((i*2,index+1,0))
				index=index+1
			else:
				bdd.append((i*2,index+2,index+1))
				bdd.append(((i*2)+1,0,aux+(i*3))) # skip to copying part
				index=index+2
			if line_goto[i]=='0':
				bdd.append(((i*2)+1,index+1,0))
				index=index+1
			else:
				if change:
					bdd.append(((i*2)+1,0,index+1))
				else:
					bdd.append(((i*2)+1,aux+(i*3),index+1))
					change=1
				index=index+1
	bdd.append((-1,1,0))
	index=index+1
	
	
	return(bdd,table)
	# end of goto

#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_goto():
	(bdd,table)=goto(6,"001", "011")
	functions.gen_gta_file(bdd,table, [1],"goto.gta")


#test_goto()

#=================================================================================

