import functions

def restrict(line):

# Automaton generated by this function is used to restrict transducer with branching to 
# just one branch.
# e.g. transducers for 'if' commands
# - there are two possible line numbers in the output set of transducer ('than' line & 'else' line)
# - by intersection with this automaton, you receive transducer just for 'than', or just for 'else'
# - line number for than/else is given by parametr of this function

# We use the following states in the automaton:
#  0 - read the normal symbols
#  1 - read symbol given by argument 'line' - ACCEPT

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.


	# BDD node 0 - normal state
	bdd.append((-1,0,0))
	index=1

       	#****************************************
	# left state=0, right state=0: 
	#****************************************
	table.append((0,0,index))
	table.append((1,0,index))
	table.append((0,1,index))
	table.append((1,1,index))
	for i in range(len(line)):
		if line[i]=="1":
			bdd.append(((i*2)+1,0,index+1))
			index=index+1
		else:
			bdd.append(((i*2)+1,index+1,0))
			index=index+1
	bdd.append((-1,1,0))
	return(bdd,table)
	# end of restrict

#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_restrict():
	(bdd,table)=restrict("001")
	functions.gen_gta_file(bdd,table, [1],"restrict.gta")


#test_restrict()

#=================================================================================

