import functions

def restrict_variable(var):

# We use the following states in the automaton:
#  0 - empty symbols on the bottom
#  1 - given variable has not been read
#  2 - given variable has been read
#  3 - top memory node + variable not read
#  4 - top memory node + variable read
#  5 - null pointers + variable not read
#  6 - null pointers + variable read
#  7 - undef pointers + variable not read
#  8 - undef pointers + variable read
#  9 - line number read - ACCEPT
#  10 - REJECT


	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.


	# BDD node 0 - reject state
	bdd.append((-1,10,0))
	index=1

       	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the first pointer descriptor (01)
	#****************************************
	table.append((0,0,index))
	bdd.append((0,index+1,0))
	# next pointer node
	bdd.append((2,index+2,index+3))
	bdd.append((-1,0,0)) # empty symbol
	bdd.append((-1,1,0)) # first pointer descriptor
	index=index+4

	#*******************************************
	# left state=0, right state=1: 
	# left state=1, right state=1: 
	# - pointer descriptor (01)
	#*******************************************
	table.append((0,1,index))
	table.append((1,1,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,1,0)) # next pointer node
	index=index+3
	#********************************************
	# left state=1 right state=0
	# - pointer descriptor (01)
	# - memory node (10)
	# - top memory node (11)
	#********************************************
	table.append((1,0,index))
	bdd.append((0,index+1,index+3))
	bdd.append((2,0,index+2))
	bdd.append((-1,1,0))
	index=index+3
	bdd.append((2,index+1,index+4))
	index=index+1
	# inner memory node
	bdd.append((4+(var*2),index+1,index+2)) #check for given variable
	bdd.append((-1,1,0))
	bdd.append((-1,2,0))
	index=index+3
	# top memory node
	bdd.append((4+(var*2),index+1,index+2)) #check for given variable
	bdd.append((-1,3,0))
	bdd.append((-1,4,0))
	index=index+3
	#*******************************************
	# left state=0, right state=2: 
	# left state=2, right state=1: 
	# left state=1, right state=2: 
	# - pointer descriptor (01)
	#*******************************************
	table.append((0,2,index))
	table.append((2,1,index))
	table.append((1,2,index))
	bdd.append((0,index+1,0))
	bdd.append((2,0,index+2))
	bdd.append((-1,2,0)) # next pointer node
	index=index+3
	#********************************************
	# left state=2 right state=0
	# - pointer descriptor (01)
	# - memory node (10)
	# - top memory node (11)
	#********************************************
	table.append((2,0,index))
	bdd.append((0,index+1,index+3))
	bdd.append((2,0,index+2))
	bdd.append((-1,2,0))
	index=index+3
	bdd.append((2,index+1,index+3))
	index=index+1
	# inner memory node
	bdd.append((4+(var*2),index+1,0)) #check for given variable
	bdd.append((-1,2,0))
	index=index+2
	# top memory node
	bdd.append((4+(var*2),index+1,0)) #check for given variable
	bdd.append((-1,4,0))
	index=index+2
	#********************************************
	# left state=1 right state=3
	# left state=0 right state=3
	# - top memory node (11)
	#********************************************
	table.append((1,3,index))
	table.append((0,3,index))
	bdd.append((0,0,index+1))
	bdd.append((2,0,index+2))
	bdd.append((4+(var*2),index+3,index+4)) #check for given variable
	bdd.append((-1,3,0))
	bdd.append((-1,4,0))
	index=index+5
	#********************************************
	# left state=1 right state=4
	# left state=0 right state=4
	# left state=2 right state=3
	# - top memory node (11)
	#********************************************
	table.append((1,4,index))
	table.append((0,4,index))
	table.append((2,3,index))
	bdd.append((0,0,index+1))
	bdd.append((2,0,index+2))
	bdd.append((4+(var*2),index+3,0)) #check for given variable
	bdd.append((-1,4,0))
	index=index+4
	#********************************************
	# left state=3 right state=0
	# - null pointers (00)
	#********************************************
	table.append((3,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(var*2),index+3,index+4)) #check for given variable
	bdd.append((-1,5,0))
	bdd.append((-1,6,0))
	index=index+5
	#********************************************
	# left state=4 right state=0
	# - null pointers (00)
	#********************************************
	table.append((4,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(var*2),index+3,0)) #check for given variable
	bdd.append((-1,6,0))
	index=index+4
	#********************************************
	# left state=5 right state=0
	# - undef pointers (00)
	#********************************************
	table.append((5,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(var*2),index+3,index+4)) #check for given variable
	bdd.append((-1,7,0))
	bdd.append((-1,8,0))
	index=index+5
	#********************************************
	# left state=6 right state=0
	# - undef pointers (00)
	#********************************************
	table.append((6,0,index))
	bdd.append((0,index+1,0))
	bdd.append((2,index+2,0))
	bdd.append((4+(var*2),index+3,0)) #check for given variable
	bdd.append((-1,8,0))
	index=index+4
	#********************************************
	# left state=8 right state=0
	# - undef pointers (00)
	#********************************************
	table.append((8,0,index))
	bdd.append((-1,9,0))
	index=index+1
	
	return(bdd,table)
	# end of restrict

#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_restrict_variable():
	(bdd,table)=restrict_variable(1)
	functions.gen_gta_file(bdd,table, [9],"restrict_var.gta")


#test_restrict_variable()

#=================================================================================

