import functions
import sys

#---------------------------------------------------------------------------

def xnext_assign_y_null(node_width,  x, y, descr_order,desc_num, line_orig,line_goto):

# We use the following states in the transducer:
#   0 - reading the init symbols
#   1 - normal processing of the main tree structure
#   2 - Read null pointers
#   3 - Read undefined pointers
#   4 - Accept (everythig read properly)
#   5 - Reject state (malformed, not the right line number, etc.) 
#   6 - null pointer exception
#   7 - undef / null pointer exception
#   8 - We guess, that next pointer descriptor have to be changed to given descriptor
#   9 - pointer descriptor was set
#   10,11,... - trace from set pointer descriptor to memory node (this node must contains x)


# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node (in bottom) / null pointers (in top) / undef pointers (in top) - see data structure description
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	# count track for a nondeterministich choice of the next state
	nondet_track=(node_width*2)


	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,5,0))#0
	index=1

       	#****************************************
	# left state=0, right state=0: 
	#   - empty nodes (00) till the first pointer description
	#   - the first pointer descriptor (01)
	#****************************************
	table.append((0,0,1))
	bdd.append((0,2,0))#1 -- the first bit of the type of the input node
	bdd.append((1,3,0))#2 -- the first bit of the type of the output node
	bdd.append((2,4,8))#3 -- if 1, we found the 1st pointer descriptor => go to line 8
	bdd.append((3,5,0))#4
	index=index+4
	bdd.append((nondet_track,index+1,index+2))
	bdd.append((-1,0,0))
	bdd.append((-1,8,0)) # we guess, that next pointer descriptor have to be changed to the given one
	index=index+3
	# a pointer descriptor (01)
	bdd.append((3,0,index+1))#6
	index=index+1
	descr_bdd=index # in the below case a pointer descriptor being read, we continue from here
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
	bdd.append((-1,1,0))
	index=index+1

	#****************************************
	#   - a memory node / a top memory node (1x)
	#   - a pointer descriptor (01)
	#   - a description of null pointers (00)
	#****************************************
	table.append((1,1,index))	
	table.append((0,1,index))
	table.append((1,0,index))
	bdd.append((0,index+1,index+4)) # pointer descriptor / memory node
	bdd.append((1,index+2,0))
	bdd.append((2,-2,index+3)) 
	aux=index+2
	bdd.append((3,0,descr_bdd)) # goto processing of a pointer descriptor
	index=index+4
	# a memory node or a top memory node
	(bdd,index)=functions.copy_n_elements_check_x_to_val(bdd,index,node_width-1,2,x+1,0)
	bdd.append((nondet_track,index+1,index+2)) #nondeterministic choice of next state
	bdd.append((-1,1,0))
	bdd.append((-1,8,0))
	index=index+3
	# null pointers
	# If x==null -> null pointer exception
	# If y!=null -> reject (this case will be solved by another transducer)
	bdd[aux]=(bdd[aux][0],index,bdd[aux][2])
	bdd.append((3,index+1,0))
	index=index+1
	if x<y: aux1=x; aux2=y
	elif y<x: aux1=y; aux2=x
	else: functions.error_msg_expl("x_next_assign_y: x==y is forbiden combinations")
	(bdd,index,id_0,id_1)=functions.copy_n_elements_and_remember_x(bdd,index,aux1+1,4,aux1)
	for i in id_0:
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	if aux1==y: 
		bdd.append((-1,5,0)) #reject - this transducer solves just case, where y==null
		index=index+1
	else:
		(bdd,index)=functions.copy_n_elements_check_x(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4,y-(x+1))
		bdd.append((-1,2,0)) # Oki - x!=null && y==null
		index=index+1
	for i in id_1:  
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	if aux1==x: # null pointer exception
		(bdd,index)=functions.copy_n_elements(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4)
		bdd.append((-1,6,0)) 
		index=index+1
	else:
		(bdd,index,id_0,id_1)=functions.copy_n_elements_and_remember_x(bdd,index,(node_width-2)-aux1-1,((aux1+1)*2)+4,aux2-(aux1+1))
		for i in id_0: # y==null && x!=null -> OK
			if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
			else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
		bdd.append((-1,2,0))
		index=index+1
		for i in id_1: 
			if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
			else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
		bdd.append((-1,6,0)) # x==null && y==null -> null pointer exception
		index=index+1

	#****************************************
	#   - we guess, that this node is searched descriptor
	#****************************************
	table.append((8,1,index))	
	table.append((8,0,index))
	bdd.append((0,index+1,0)) # It have to be pointer descriptor
	bdd.append((1,index+2,0))
	bdd.append((2,0,index+3)) 
	bdd.append((3,0,index+4))
	index=index+4
	bdd.append((5,index+1,0))	
	bdd.append((7,0,index+2))	
	bdd.append((9,index+3,0))	
	index=index+3
	# NOW copy the rest of the pointer descriptor node up to the node_width
	# This is usefull only in case of enabled variance analysis on descriptors
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width-(desc_num+2),4+(desc_num*2))
	bdd.append((-1,9,0))
	index=index+1

	#*********************************************
	# Trace of pointer descriptor
	# if descr_order==0 -> no trace
	#*********************************************
	for i in range(descr_order):
		table.append((0,9+i,index))
		table.append((1,9+i,index))
		bdd.append((0,index+1,0))
		bdd.append((1,index+2,0))
		bdd.append((2,0,index+3)) 
		bdd.append((3,0,index+4))
		index=index+4
		(bdd,index)=functions.copy_n_elements(bdd,index,node_width-2,4)
		bdd.append((-1,10+i,0))
		index=index+1
	table.append((9+descr_order,0,index))
	table.append((9+descr_order,1,index))
	bdd.append((0,0,index+1)) #check for memory node (1x)
	bdd.append((1,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_n_elements_check_x(bdd,index,node_width-1,2,x+1)
	bdd.append((-1,1,0));
	index=index+1
	
	#----------------------------------------
	#  - undefined pointers
	#    Here, we are going to check, if x is undefined, of not. (y is null - checked before)
	# If x is undefined -> null pointer exception is raised (return state XXXXX)
	# Otherwise, return state 3 is given
	#---------------------------------------
	table.append((2,0,index))
	bdd.append((0,index+1,0))
	bdd.append((1,index+2,0))
	bdd.append((2,index+3,0)) 
	bdd.append((3,index+4,0))
	index=index+4
	if x==y: functions.error_msg_expl("x_next_assign_y: x==y is forbiden combinations")
	(bdd,index,id_ok,id_except)=functions.copy_n_elements_and_remember_x(bdd,index,node_width-2,4,x)
	for i in id_except: # undef pointer exception
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,7,0)) 
	index=index+1
	for i in id_ok: 
		if i[1]==1: bdd[i[0]]=(bdd[i[0]][0],index,bdd[i[0]][2])
		else: bdd[i[0]]=(bdd[i[0]][0],bdd[i[0]][1],index)
	bdd.append((-1,3,0)) 
	index=index+1

	# ****************************************
	# left state=6, right state=0:
	#  - null pointer exception - read of undef pointers
	# ****************************************	
	table.append((6,0,index))	
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,0)
	bdd.append((-1,7,0))
	index=index+1

	# ****************************************
	# left state=7, right state=0:
	#  - a line number change to undef/null pointer exception
	# ****************************************	
	table.append((7,0,index))	
	(bdd,index)=functions.change_line_num_to_err(bdd,index,line_orig)
	bdd.append((-1,4,0)) # accept
	index=index+1
	# ****************************************
	# left state=3, right state=0:
	#  - a line number change 
	# ****************************************	
	table.append((3,0,index))	
	(bdd,index)=functions.change_line_num(bdd,index,line_orig,line_goto)
	bdd.append((-1,4,0)) # accept
	index=index+1

	return(bdd,table)

#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_gen_x_next_assign_y_null():
	(bdd,table)=xnext_assign_y_null(9,4,1,3,2,"000","001")
	functions.gen_gta_file(bdd,table, [4],"xnext_assign_y=null.gta")


#test_gen_x_next_assign_y_null()


