import functions
import sys


def shape_to_descr(node_width, pointer_num, marker):

# pointer_num - munber of pointer variables
# marker - marker identificator

# This function generates transducer for 'shape automaton'
# INPUT:  'shape automaton' Contains just 2 tracks (1 & 3)
# 00 - nothing
# 10 - sorce
# 01 - destination
# 11 - sorce/destination in one node
# There is just one node in automaton with 1 in 1st track, and one node with 1 in 3rd track
# This automaton has similar shape like original one, but it is possible to handle its contains easily.
#
# OUTPUT: pointer descriptor
#   - all track in this pointer descriptor are '+4' -> It is necessary to remap 4->0, 5->1, 6->2

# We use the following states in the transducer:
#   0 - normal processing (one state transducer)
#   1 - reject states

# These are the codes of the types of the tree nodes (the first two bits, for transducers four bits: 1.in,1.out,2.in,2.out)
#   00 - an empty node
#   01 - a pointer descriptor
#   10 - a memory node
#   11 - a top memory node (above which there are only other top nodes and then the null & undef. pointers and the line number)
	
	# It is necessary to count with code of tree nodes - tracks 0 & 2
	# and with fact that input is just in odd tracks

	table=[] # The main transition table States x States --> BDD nodes
	bdd=[]   # Further looking up of the next state for the given situation.
                 # The triple is (the bit of input, the next BDD node for 0, the next BDD node for 1).
		 # (-1,x,_) then means that the target state has been found and it's x.

	#****************************************
	# bdd node 0 = a reject state
	#****************************************
	bdd.append((-1,1,0))#0
	index=1

       	#***************************************************************
	# processing 
       	#***************************************************************
	table.append((0,0,1))
	bdd.append((1,index+1,-2)) # check for 'from' position
	aux=index
	bdd.append((3,index+2,-2)) # check for 'to' position
	aux2=index+1
	index=index+2
	# 00 from & to positions are unset - just create copying rule.
	(bdd,index)=functions.copy_n_elements(bdd,index,node_width,4)
	bdd.append((-1,0,0))		
	index=index+1
	# 01 to pointer is unset
	# It is necessary to check marker, and set token
	bdd[aux2]=(bdd[aux2][0],bdd[aux2][1],index)
	bdd.append((4,0,index+1)) # It must be memory node - we check it
	bdd.append((5,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_node_return_state_dep_on_x_set_y(bdd,index,node_width-1,6,pointer_num+marker+1,pointer_num+1,1,0)
	#-----------------
	# from position is set
	bdd[aux]=(bdd[aux][0],bdd[aux][1],index)
	bdd.append((3,index+1,-2)) # check for 'to' position
	aux2=index
	index=index+1
	# 'from' position is set & to position is not set
	# - check for a token and unset it
	bdd.append((4,0,index+1)) # It must be memory node - we check it
	bdd.append((5,0,index+2))
	index=index+2
	(bdd,index)=functions.copy_node_return_state_dep_on_x_unset_y(bdd,index,node_width-1,6,pointer_num+1,pointer_num+1,1,0)
	# This is the situation, where node points to itself:
	# - check for token & and for a marker
	bdd[aux2]=(bdd[aux2][0],bdd[aux2][1],index)
	bdd.append((4,0,index+1)) # It must be memory node - we check it
	bdd.append((5,0,index+2))
	index=index+2
	# first, copy just part of node & check for token
	(bdd,index)=functions.copy_n_elements_check_x(bdd,index,pointer_num+2,6,pointer_num+1)
	# secondaly, copy rest & check for marker
	(bdd,index)=functions.copy_n_elements_check_x(bdd,index,node_width-3-pointer_num,10+(pointer_num*2),marker-1)
	bdd.append((-1,0,0))
	index=index+1
	return(bdd,table)

#--------------------------------------------------------------------------------
#              T E S T S
#--------------------------------------------------------------------------------

def test_shape_to_descr():
	(bdd,table)=shape_to_descr(8,3,1)
	functions.gen_gta_file(bdd,table, [0],"shape_to_descr.gta")

#test_shape_to_descr()


#=================================================================================

