/* Generated By:JavaCC: Do not edit this line. OrderParser.java */
package parser ;

import java.util.* ;


/**
 * The order parser class.
 *
 * @author Pierre Salagnac
 */
public class OrderParser implements OrderParserConstants {

  // values list
  private Map<String,Integer> values ;

  // indexes offset
  private int offset ;


  /**
   * Initialize the parser before starting the parse process.
   *
   * @param offset The indexes offset.
   */
  private void init(int offset) {

    this.offset = offset ;

    if (values == null)
      values = new HashMap<String,Integer>() ;
    else
      values.clear() ;

  }


  /**
   * Start the parse process without index offset.
   *
   * @exception ParseException The order is invalid.
   */
  public void parse() throws ParseException {
    parse(0) ;
  }


  /**
   * Return the index of the specified input.
   * 
   * @return The index of the input, or -1 is the name is not found.
   */
  public int getInputIndex(String name) {

    Integer integer = values.get(name) ;

    if (integer == null)
      return -1 ;
    else
      return integer.intValue() ;

  }


  /**
   * Return is the specified input is declared.
   * 
   * @param name The input name.
   * 
   * @return true if the input has an index.
   */
  public boolean containsInput(String name) {

    return (getInputIndex(name) >= 0) ;

  }


  /**
   * Return the specified input name.
   *
   * @param index The input index.
   *
   * @return The input name.
   */
  public String getInput(int index) {

    Integer integer = Integer.valueOf(index) ;

    for (String name : values.keySet()) {

      Integer position = values.get(name) ;
      if (integer.equals(position))
        return name ;
    }

    throw new IllegalArgumentException("no such input: "+index) ;
  }


  /**
   * Return the number of declared inputs.
   * 
   * @return The input count
   */
  public int getInputCount() {

    return values.size() ;

  }


  /**
   * Add a parsed value.
   * 
   * @param name The name of the input.
   * @param order The position of the input.
   *
   * @exception ParseException There is a duplicated value.
   */
  private void addValue(String name,int order) throws ParseException {

    int position = order+offset ;
    if (position < 0) {
      throw new ParseException("negative index: "+name+'='
      +position+" ("+order+','+offset+')') ;
    }
    Integer integer = Integer.valueOf(position) ;

    if (values.containsKey(name))
      throw new ParseException("duplicate name: "+name) ;

    if (values.containsValue(integer))
      throw new ParseException("duplicate index: "+position+" ("+order+','+offset+')') ; ;

    values.put(name,integer) ;

  }


  /**
   * Throws an exception if the order is invalid.
   *
   * @exception ParseException The order is invalid.
   */
  private void checkOrder() throws ParseException {

    int size = values.size() ;

    // search minimum
    int minIndex = Integer.MAX_VALUE ;
    for (Integer integer : values.values()) {
      int value = integer.intValue() ;
      if (value < minIndex)
        minIndex = value ;
    }

    // reject missing values
    for (int i=0;i<size;i++) {

      Integer integer = Integer.valueOf(i+minIndex) ;

      if (!values.containsValue(integer))
        throw new ParseException("missing index in order: "+i) ;
    }
  }

  final public void parse(int ofs) throws ParseException {
  String name ;
  int index ;

  init(ofs) ;
    label_1:
    while (true) {
      name = parseIdentifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        break;
      case EQUAL:
        jj_consume_token(EQUAL);
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      index = parseInteger();
     addValue(name,index) ;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[1] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_1;
      }
    }
    checkOrder() ;
  }

  final private String parseIdentifier() throws ParseException {
  Token token ;
    token = jj_consume_token(IDENTIFIER);
   {if (true) return token.image ;}
    throw new Error("Missing return statement in function");
  }

  final private int parseInteger() throws ParseException {
  Token token ;
    token = jj_consume_token(INTEGER);
    {if (true) return Integer.parseInt(token.image) ;}
    throw new Error("Missing return statement in function");
  }

  public OrderParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[3];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x180,0x200,0x800,};
   }

  public OrderParser(java.io.InputStream stream) {
     this(stream, null);
  }
  public OrderParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new OrderParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public OrderParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new OrderParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public OrderParser(OrderParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public void ReInit(OrderParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[14];
    for (int i = 0; i < 14; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 3; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 14; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
