/* Generated By:JavaCC: Do not edit this line. TypedefParser.java */
package parser ;


/**
 * The typedef parser class.
 *
 * @author Pierre Salagnac
 */
public class TypedefParser implements TypedefParserConstants {

  // events handler
  private ParseHandler handler ;

  /**
   * Initialize the parser before starting the parse process.
   */
  private void init() {

    handler = new ParseHandler() ;

  }


  /**
   * Return the list of parsed types.
   *
   * @return the parsed typedefs.
   */
  public Typedef[] getTypedefs() {

    return handler.getTypedefs() ;

  }

  final public void parse() throws ParseException, PathException {
  init() ;
    label_1:
    while (true) {
      parseTypedef();
      jj_consume_token(SEMICOLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYPEDEF:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
    }
    jj_consume_token(0);
  }

  final private void parseTypedef() throws ParseException, PathException {
  Token name ;
    jj_consume_token(TYPEDEF);
    jj_consume_token(STRUCT);
    // type name
      name = jj_consume_token(IDENTIFIER);
    handler.addTypedef(name.image) ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ROUTING_OPEN:
      parseRootList();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    jj_consume_token(OPENING_BRACE);
    parseMembers();
    handler.addMember(null,null) ;
    jj_consume_token(CLOSING_BRACE);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OR:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      jj_consume_token(OR);
      handler.addTypedef(name.image) ;
      jj_consume_token(OPENING_BRACE);
      parseMembers();
      jj_consume_token(CLOSING_BRACE);
      handler.addMember(null,null) ;
    }
  }

  final private void parseMembers() throws ParseException, PathException {
  Token type ;
  Token name ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DATA:
      parseDataMember();
      break;
    default:
      jj_la1[3] = jj_gen;
      ;
    }
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRUCT:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_3;
      }
      jj_consume_token(STRUCT);
      type = jj_consume_token(IDENTIFIER);
      jj_consume_token(STAR);
      name = jj_consume_token(IDENTIFIER);
      jj_consume_token(SEMICOLON);
      handler.addMember(type.image,name.image) ;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ROUTING_OPEN:
        jj_consume_token(ROUTING_OPEN);
        handler.startRouting() ;
        parseRoutingExpr();
        handler.endRouting()   ;
        jj_consume_token(ROUTING_CLOSE);
        break;
      default:
        jj_la1[5] = jj_gen;
        ;
      }
    }
  }

  final private void parseRootList() throws ParseException {
  Token name ;
    jj_consume_token(ROUTING_OPEN);
    label_4:
    while (true) {
      name = jj_consume_token(IDENTIFIER);
      handler.addRootVariable(name.image) ;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_4;
      }
    }
    jj_consume_token(ROUTING_CLOSE);
  }

  final private void parseDataMember() throws ParseException {
    jj_consume_token(DATA);
    jj_consume_token(EQUAL);
    String data = parseBinary() ;
    handler.addData(data) ;
    jj_consume_token(SEMICOLON);
  }

  final private void parseRoutingExpr() throws ParseException, PathException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NULL:
      jj_consume_token(NULL);
      handler.addNullPath() ;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OR:
        jj_consume_token(OR);
        parsePath();
        break;
      default:
        jj_la1[7] = jj_gen;
        ;
      }
      break;
    case MINUS:
    case OPENING_PAR:
    case ROOT:
    case LEAF:
    case IDENTIFIER:
      parsePath();
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private void parsePath() throws ParseException, PathException {
  String multiplicity = null ;
  String end = null ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MINUS:
    case ROOT:
    case LEAF:
    case IDENTIFIER:
      parseMove();
      break;
    case OPENING_PAR:
      jj_consume_token(OPENING_PAR);
      handler.startSubpath() ;
      parsePath();
      jj_consume_token(CLOSING_PAR);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case INTEGER:
        multiplicity = parseMultiplicity();
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ROOT:
      case LEAF:
        end = parseEndPoint();
        break;
      default:
        jj_la1[10] = jj_gen;
        ;
      }
      handler.endSubpath(multiplicity,end) ;
      break;
    default:
      jj_la1[11] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
    case OR:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OR:
        jj_consume_token(OR);
      handler.addDisjunction() ;
        parsePath();
        break;
      case COMMA:
        jj_consume_token(COMMA);
        parsePath();
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
  }

  final private void parseMove() throws ParseException, PathException {
  String start = null ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ROOT:
    case LEAF:
      start = parseEndPoint();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MINUS:
      case IDENTIFIER:
        parseMove2(start);
        break;
      default:
        jj_la1[14] = jj_gen;
        handler.addMove(start,false,null,null,null) ;
      }
      break;
    case MINUS:
    case IDENTIFIER:
      parseMove2(null);
      break;
    default:
      jj_la1[15] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private void parseMove2(String start) throws ParseException, PathException {
  boolean reverse = false ;
  Token name ;
  String multiplicity = null ;
  String end = null ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MINUS:
      jj_consume_token(MINUS);
      reverse = true ;
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    // name of the pointer in the structure
      name = jj_consume_token(IDENTIFIER);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STAR:
    case INTEGER:
      multiplicity = parseMultiplicity();
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ROOT:
    case LEAF:
      end = parseEndPoint();
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    handler.addMove(start,reverse,name.image,multiplicity,end) ;
  }

  final private String parseMultiplicity() throws ParseException {
  Token token ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      //constant number
          token = jj_consume_token(INTEGER);
      break;
    case STAR:
      // undefined
          token = jj_consume_token(STAR);
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return token.image ;}
    throw new Error("Missing return statement in function");
  }

  final private String parseEndPoint() throws ParseException {
  Token token ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ROOT:
      // root
          token = jj_consume_token(ROOT);
      break;
    case LEAF:
      // leaf
          token = jj_consume_token(LEAF);
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return token.image ;}
    throw new Error("Missing return statement in function");
  }

  final private int parseInteger() throws ParseException {
  Token token ;
    token = jj_consume_token(INTEGER);
    {if (true) return Integer.parseInt(token.image) ;}
    throw new Error("Missing return statement in function");
  }

  final private String parseBinary() throws ParseException {
  Token token ;
    token = jj_consume_token(BINARY);
    int length = token.image.length() ;
    {if (true) return token.image.substring(1,length-1) ;}
    throw new Error("Missing return statement in function");
  }

  public TypedefParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[21];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x80000,0x20000,0x2000000,0x200000,0x100000,0x20000,0x10000000,0x2000000,0x11c08100,0x4000200,0xc00000,0x10c08100,0x2000080,0x2000080,0x10000100,0x10c00100,0x100,0x4000200,0xc00000,0x4000200,0xc00000,};
   }

  public TypedefParser(java.io.InputStream stream) {
     this(stream, null);
  }
  public TypedefParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new TypedefParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public TypedefParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new TypedefParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public TypedefParser(TypedefParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public void ReInit(TypedefParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[32];
    for (int i = 0; i < 32; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 21; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 32; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
