/*
 * AutomataBuilder.java
 */
package automata ;


/**
 * Abstract class, useful for rules construction.
 * 
 * @author Pierre Salagnac
 */
abstract class AutomataBuilder {

  // state counter
  private int stateIndex ;
  
  /**
   * Creates a new instance.
   */
  AutomataBuilder() {
    
    
  }
  
  
  /**
   * Creates a new automata state. Each returned state is unique.
   * 
   * @return A new state.
   */
  String createState() {
    
    StringBuffer buffer = new StringBuffer() ;
    
    buffer.append('A') ;
    
    stateIndex++ ;
    buffer.append(stateIndex) ;
    
    return buffer.toString() ;
  }
  
  
}
