/*
 * Created on 19 dc. 2003
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package cril.calife.export.engine;

import java.util.HashSet;
import java.util.Hashtable;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import cril.calife.export.typechecker.TypeChecker;
import cril.calife.export.typechecker.TypeSystem;
import cril.calife.locales.Messages;
import cril.calife.utils.DOMUtil;

/**
 * @author bertrand.tavernier
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class AutomataBuilder {
	/**
	 * Construit un document transformable par XSL
	 * renvoit null quand le document n'est pas correctement typ
	 * @param Hashtable ht_modeles
	 * @param String str_source
	 * @return
	 */

	public static Document buildDocument(
			Hashtable ht_modeles,
			String str_source) {

		Document d_scr = (Document) ht_modeles.get(str_source);
		boolean correct = true;
		if (d_scr != null) {
			Document d_res = DOMUtil.cloneDocument(d_scr);
			if (d_res.getDocumentElement().getNodeName().equals("Block")) { //$NON-NLS-1$
				correct = fillAutomataInBlock(ht_modeles, d_res);
			}
			else {
				System.out.print(
						Messages.getString("DOMUtil.m_tc") //$NON-NLS-1$
						+ ((Element)d_res.getFirstChild()).getAttribute("Label") //$NON-NLS-1$
						+ Messages.getString("DOMUtil.m_tc2")); //$NON-NLS-1$
				TypeChecker tc = new TypeChecker(d_res.getDocumentElement()
				        						,buildTypeSystem(d_res));
				correct = tc.TypeCheck();
				if (!correct)
					System.err.println("Erreur de typage !\n");
				else {
					System.out.println(" OK");
				}
			}
			if (!correct) //$NON-NLS-1$
				return null;
			return d_res;
		}
		return null;
	}

	public static TypeSystem buildTypeSystem(Document d_block) {
	    TypeSystem ts = new TypeSystem();
	    
	    Element[] list = DOMUtil.getElementByTagName(d_block.getDocumentElement(),"Fun");
	    for (int it=0;it<list.length;it++)
	        ts.addFunction(list[it]);
	    list = DOMUtil.getElementByTagName(d_block.getDocumentElement(),"Cast");
	    for (int it=0;it<list.length;it++)
	        ts.addCast(list[it]);
	    list = DOMUtil.getElementByTagName(d_block.getDocumentElement(),"ConstType");
	    for (int it=0;it<list.length;it++)
	        ts.addConstType(list[it]);
	    list = DOMUtil.getElementByTagName(d_block.getDocumentElement(),"Var");
	    for (int it=0;it<list.length;it++)
	        ts.addVariable(list[it]);
	    list = DOMUtil.getElementByTagName(d_block.getDocumentElement(),"Param");
	    for (int it=0;it<list.length;it++)
	        ts.addParameter(list[it]);
	    
	    return ts;
	}
	
	private static boolean fillAutomataInBlock(
			Hashtable ht_modeles,
			Document d_block) {
		
		HashSet col = new HashSet(); 		
		NodeList nlComp =
		DOMUtil
		.getChildNamed(d_block.getDocumentElement(), "Components") //$NON-NLS-1$
		.getChildNodes();
		boolean res = true;
		for (int it = 0; it < nlComp.getLength(); it++) {
			if (nlComp.item(it).getNodeName().equals("Component")) { //$NON-NLS-1$
				if (DOMUtil.NtoE(nlComp.item(it)).getAttribute("Type").equals("Automata")) { //$NON-NLS-1$ //$NON-NLS-2$
					Document dTemp =
					((Document) ht_modeles
							.get(DOMUtil.NtoE(nlComp.item(it)).getAttribute("Label"))); //$NON-NLS-1$

					System.out.print(
							Messages.getString("DOMUtil.m_tc") //$NON-NLS-1$
							+ DOMUtil.NtoE(nlComp.item(it)).getAttribute("Label") //$NON-NLS-1$
							+ "(" //$NON-NLS-1$
							+ DOMUtil.NtoE(nlComp.item(it)).getAttribute("Index") //$NON-NLS-1$
							+ ")" //$NON-NLS-1$
							+ Messages.getString("DOMUtil.m_tc2")); //$NON-NLS-1$
					TypeChecker tc = new TypeChecker(dTemp.getDocumentElement(),
					        						 buildTypeSystem(dTemp));
					if (!tc.TypeCheck()) { 
							res = false;
							System.err.println("Erreur de typage !\n");
					} else {
						System.out.println(" OK");
					}
					
					col.add(dTemp);
					
				} else if (
						DOMUtil.NtoE(nlComp.item(it)).getAttribute("Type").equals("Block")) { //$NON-NLS-1$ //$NON-NLS-2$
					Document dBlock =
					DOMUtil.cloneDocument(
							((Document) ht_modeles
							.get(DOMUtil.NtoE(nlComp.item(it)).getAttribute("Label")))); //$NON-NLS-1$
					fillAutomataInBlock(ht_modeles, dBlock);
					col.add(dBlock);
				}
			}
		}
		Object[] allDom = col.toArray();
		Node nT = d_block.createElement("Templates"); //$NON-NLS-1$
		for (int it=0;it<allDom.length;it++) {
			Document dAuto = DOMUtil.cloneDocument((Document)allDom[it]);
			Node nAuto = dAuto.getDocumentElement();
			nAuto.removeChild(DOMUtil.getChildNamed(nAuto, "Model")); //$NON-NLS-1$
			nT.appendChild(d_block.importNode(nAuto,true));
		}		
		
		d_block.getDocumentElement().appendChild(nT); //Ajout des templates
		return res;
	}
}
