/*
 * Created on 3 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package cril.calife.export.typechecker;

import java.util.ArrayList;

import org.w3c.dom.Element;

/**
 * @author bertrand.tavernier
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class TypeCaster {
	
	public static int getCastLength(TypeSystem ts, String arg, String sig) { 
		int result = 0;
		String[] v_arg = arg.split(":"); 
		String[]v_sig = sig.split(":"); 
		
		if (v_arg.length!=v_sig.length) return -1; // Fonctions d'arrit diffrente : pas de cast

		int itmp;
		for (int it=0;it<v_arg.length;it++) {
			itmp = isCastAllowed(ts,v_arg[it],v_sig[it]);
			if (itmp<0) return -1; // Pas de cast entre les 2 arguments
			result += itmp;
		}
		return result;
	}

	public static int isCastAllowed(TypeSystem ts,String fType,String tType) {
		if (fType.equals(tType))
			return 0;
		if (fType.indexOf('[')>0) {
			String fsubTerm = fType.substring(fType.indexOf('[')+1,fType.indexOf(']'));
			String tsubTerm = tType.substring(tType.indexOf('[')+1,tType.indexOf(']'));
			if (tsubTerm.indexOf('<')>=0) {
				tsubTerm = tsubTerm.substring(tsubTerm.indexOf('<')+1,tsubTerm.indexOf('>'));
				return isCastAllowed(ts,findSortOf(ts,fsubTerm),tsubTerm);
			}
		}
		return isCastAllowed(ts,fType,tType,1);
	}

	private static int isCastAllowed(TypeSystem ts,String fType,String tType,int depth) {
		ArrayList nl_Cast = ts.getCasts(); 
		ArrayList castlist = new ArrayList();
		for(int it=0;it<nl_Cast.size();it++) {
			if (((Element)nl_Cast.get(it)).getAttribute("From").equals(fType)) { 
				if (((Element)nl_Cast.get(it)).getAttribute("To").equals(tType)) { 
					return depth;
				} else {
					// un cast a t trouv mais n'est toujours pas bon -> Appel recursif
				    castlist.add(((Element)nl_Cast.get(it)).getAttribute("To")); 
				}
			}
		}
		for (int it=0;it<castlist.size();it++) {
		    int res = isCastAllowed(ts,(String)castlist.get(it),tType,++depth);
		    if (res>=0)
		        return res;		    
		}
		    
		return -1;
	}

	public static String findSortOf(TypeSystem ts, String str_term) {
		String result = null;

		ArrayList v_decl = ts.getConstTypes(); 
		Element e_decl;
		String str_type;
		for (int it=0;it<v_decl.size();it++) {
			e_decl = (Element)v_decl.get(it);
			if (str_term.matches(e_decl.getAttribute("Match"))) { 
				if (result!=null) {
					str_type = e_decl.getAttribute("Label");
					if (isCastAllowed(ts,str_type,result)>0) {
						result = str_type;
					}
				} else {
					result = e_decl.getAttribute("Label");
				}
			}
		}	
		return result;
	}
	
}
