/*Copyright (C) 2002  Bertrand Tavernier (CRIL Technology)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

package cril.calife.utils;

/**
 * Filtre d'extension pour JFileChooser et File
 * @author Bertrand Tavernier
 */

public class FiltreExt extends javax.swing.filechooser.FileFilter
	implements java.io.FileFilter {

   String extension;
   String description;
   boolean acceptDir;

   	/**
   	 * Nouveau filtre d'extension pour JFileChooser et File
   	 * @param extension Extension  filter
   	 * @param description Description du type de fichier
   	 */
   
	 public FiltreExt(String extension, String description) {
				 if (extension.indexOf('.') == -1)
						 extension = "." + extension;

				 this.extension = extension;
				 this.description = description;
				 this.acceptDir = true;
		 }

	/**
	 * Nouveau filtre pour JFileChooser et File
	 * @param extension Extension sur laquelle filtrer
	 * @param description Description du type associ
	 * @param acceptDir Accepte les rpertoires
	 */ 
	 
   public FiltreExt(String extension, String description, boolean acceptDir) {
       if (extension.indexOf('.') == -1)
           extension = "." + extension;

       this.extension = extension;
       this.description = description;
       this.acceptDir = acceptDir;
   }

   public boolean accept(java.io.File fichier) {
       // vrifie si le le fichier finit avec l'extension que nous avons spcifi
       // dans le constructeur, et, dans ce cas "accepter" de l'afficher dans la
       // fentre du JFileChooser
       if (fichier.getName().toLowerCase().endsWith(extension.toLowerCase()))
	   return true;
       // les rpertoires aussi doivent tre affichs dans la fentre du JFileChooser
       else if (fichier.isDirectory())
	   return this.acceptDir;

       return false;
   }

   public String getDescription() {
       return this.description + " (*" + extension + ")";
   }
}