/*
 * Created on 1 avr. 2004
 *
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package cril.calife.utils;

import java.awt.Component;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.awt.image.RenderedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;


/**
 * @author bertrand.tavernier
 *
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class ImageUtil {
	
	public static int OK = 1;
	public static int ERROR = 1;
	
	/**
	 * Create une image du composant pass en paramtre
	 * @param comp composant source de l'image
	 * @param str_type jpg / wmf
	 * @param filename nom du fichier  crer
	 * @return statut
	 */
	
	public static RenderedImage createImage(Component comp, int width, int height) {
		BufferedImage image;
		 /*if (comp instanceof Canvas3D) {
			Canvas3D canvas = (Canvas3D) comp;
			   canvas.waitForOffScreenRendering();

			    GraphicsContext3D  ctx = canvas.getGraphicsContext3D();
			    int w=0,h=0;
			    boolean resized = false;
			    if (width>0) {
			    	w = canvas.getWidth();
			    	h = canvas.getHeight();
			    	resized = true;
			    	canvas.setSize(width,height);
			    	
			    } else {
			    	width = canvas.getWidth();
			    	height = canvas.getHeight();
			    }

			    BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
			    ImageComponent2D im = new ImageComponent2D(ImageComponent.FORMAT_RGB, bi);
			    Raster ras = new Raster(new Point3f( -1.0f, -1.0f, -1.0f ),
			                            Raster.RASTER_COLOR, 0, 0, width, height, im, null );

			    ctx.flush(true);
			    ctx.readRaster( ras );
			    image = ras.getImage().getImage();
			    if (resized)
			    	canvas.setSize(w,h);
			    

		} else*/  { 
			int w = comp.getWidth(), h = comp.getHeight();
		    boolean resized = false;
		    if (width>0) {
		    	w = comp.getWidth();
		    	h = comp.getHeight();
		    	resized = true;
		    	comp.setSize(width,height);
		    } else {
		    	width = comp.getWidth();
		    	height = comp.getHeight();
		    }
			
			image = new BufferedImage(width, height,
                BufferedImage.TYPE_INT_RGB);
            Graphics2D g2 = image.createGraphics();
            comp.paint(g2);
            if (resized)
            	comp.setSize(w,h);
            g2.dispose();
            
		}
		return image;
	}
	
	public static int saveImage(RenderedImage b,String str_type, String filename) {
		try {
			ImageIO.write(b, str_type, new File(filename));
			return OK;
		} catch (IOException e) {
			return ERROR;
		}
	}
	
	public static int saveImage(Component comp,String str_type, String filename,int w, int h) {
		try {
			ImageIO.write(createImage(comp,w,h), str_type, new File(filename));
			return OK;
		} catch (IOException e) {
			return ERROR;
		}
	}
}
