/* Copyright (C) 2003  Bertrand Tavernier (CRIL Technology)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

package cril.calife.utils;

import java.util.ArrayList;

import org.w3c.dom.*;

/**
 * @author bertrand.tavernier
 * 4 juin 2003
 */
public class VarUtil {

	public static Element getEnvironnement(Document Dom) {
		return DOMUtil.getChildNamed(
			Dom.getDocumentElement(),
			"Environment");
	}
	public static ArrayList getLocalVar(Document DOM) {
		Element eLocal =
			(Element) VarUtil.getEnvironnement(DOM).getElementsByTagName(
				"Local").item(
				0);
		ArrayList v_result = DOMUtil.copyNodeList(eLocal.getElementsByTagName("Var"));
		v_result.addAll(DOMUtil.copyNodeList(eLocal.getElementsByTagName("Param")));
		return v_result;
	}

	public static ArrayList getExternVar(Document DOM) {
		Element eLocal =
			(Element) VarUtil.getEnvironnement(DOM).getElementsByTagName(
				"External").item(
				0);
		ArrayList v_result = DOMUtil.copyNodeList(eLocal.getElementsByTagName("Var"));
		v_result.addAll(DOMUtil.copyNodeList(eLocal.getElementsByTagName("Param")));
		return v_result;
	}

	public static void untypeVar(Document DOM, String str_varlabel) {
		untypeVar(DOM,str_varlabel,"VExt");
		untypeVar(DOM,str_varlabel,"PExt");
		untypeVar(DOM,str_varlabel,"VLoc");
		untypeVar(DOM,str_varlabel,"PLoc");
	}

	public static void untypeVar(Document dom,String str_label,String str_typedName) {
		NodeList allNodes = dom.getElementsByTagName(str_typedName);
		ArrayList v_filtred = new ArrayList();
		for (int it = 0; it < allNodes.getLength(); it++)
			if (allNodes.item(it).getFirstChild().getNodeValue().equals(str_label))
				v_filtred.add(allNodes.item(it));

		for (int it = 0; it < v_filtred.size(); it++) {
			Element eNew = dom.createElement("VAR");
			eNew.setAttribute("Type", "Undef");
			eNew.appendChild(
				dom.createTextNode(
					((Node) v_filtred.get(it)).getFirstChild().getNodeValue()));
			((Node) v_filtred.get(it)).getParentNode().replaceChild(
				eNew,
				((Node) v_filtred.get(it)));
		}
	}

}
