/*
 * Copyright (C) 2003 Bertrand Tavernier (CRIL Technology)
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package cril.calife.utils;
/**
 * @author bertrand.tavernier 13 mai 2003
 */

import javax.swing.JOptionPane;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXParseException;
/**
 * Manager of error on XML.
 */
public class XMLErrorManager implements ErrorHandler {
	private String str_doc = "";
		
	/**
	 * Class constructor.
	 */
	public XMLErrorManager(String str_doc) {
		super();
		this.str_doc = str_doc;
	}
	/**
	 * Warning error.
	 * 
	 * @param exception
	 *            an exception
	 */
	public void warning(SAXParseException exception) {
		JOptionPane.showMessageDialog(null, exception.getMessage() + "\n",
				"Warning", JOptionPane.WARNING_MESSAGE);
		return;
	}
	/**
	 * error manager.
	 * 
	 * @param exception
	 *            an exception
	 */
	public void error(SAXParseException exception) {
		JOptionPane.showMessageDialog(null, exception.getMessage() + "\n",
				"Erreur sur la DTD du document " + str_doc,
				JOptionPane.ERROR_MESSAGE);
		return;
	}
	/**
	 * fatal error manager.
	 * 
	 * @param exception
	 *            an exception
	 */
	public void fatalError(SAXParseException exception) {
		JOptionPane.showMessageDialog(null, exception.getMessage() + "\n",
				"Erreur sur la DTD du document " + str_doc,
				JOptionPane.ERROR_MESSAGE);
		return;
	}
}